// Generated by CoffeeScript 1.8.0
(function() {
  this.display_js_view_player = function(dom) {
    var height, max_width, player, player_button, player_left, player_top, real_player, width;
    player = $(dom);
    width = player.attr('data-width') || $(window).width() * 0.8;
    height = player.attr('data-height') || $(window).height() * 0.8;
    width = parseInt(width);
    height = parseInt(height);
    max_width = parseInt($(window).width() * 0.9);
    if (width > max_width) {
      height = parseInt(max_width / width * height);
      width = max_width;
    }
    real_player = $(player.attr('href')).find('video').parent();
    player_button = real_player.find('.vjs-big-play-button');
    player_left = (width - player_button.width()) / 2;
    player_top = (height - player_button.height()) / 2;
    player_button.css('left', player_left);
    player_button.css('top', player_top);
    real_player.css('width', width);
    real_player.css('height', height);
    player.colorbox({
      inline: true,
      innerWidth: width,
      innerHeight: height,
      onComplete: function() {
        var video;
        player = $(this);
        video = videojs('#player_' + player.attr('href').slice(1));
        video.play();
        real_player = $(player.attr('href')).find('video').parent();
        real_player.css('width', width);
        return real_player.css('height', height);
      },
      onClosed: function() {
          var video;
          player = $(this);
          video = videojs('#player_' + player.attr('href').slice(1));
          return video.pause();
      }
    });
    return false;
  };

  this.display_js_view_html = function(dom) {
    var inner_html;
    inner_html = $(dom).children('.js_view_inner_html').html();
    $.colorbox({
      html: inner_html
    });
    return false;
  };

  this.display_js_view_iframe = function(dom) {
    var iframe_src;
    dom = $(dom);
    iframe_src = $(dom).attr('href');
    $.colorbox({
      iframe: true,
      width: '80%',
      height: '80%',
      href: iframe_src
    });
    return false;
  };

  this.display_js_view_image = function(dom) {
    var group_id, link_url, title;
    dom = $(dom);
    link_url = dom.attr('href');
    title = dom.attr('title') || '';
    group_id = dom.attr('data-group-id');
    if (!group_id) {
      $.colorbox({
        photo: true,
        maxWidth: '100%',
        maxHeight: '100%',
        href: link_url,
        title: title,
        rel: group_id
      });
    }
    return false;
  };

  this.show_js_view = function(dom) {
    dom = $(dom);
    if (dom.hasClass('js_view_video')) {
      return display_js_view_player(dom);
    } else if (dom.hasClass('js_view_html')) {
      return display_js_view_html(dom);
    } else if (dom.hasClass('js_view_iframe')) {
      return display_js_view_iframe(dom);
    } else if (dom.hasClass('js_view_image')) {
      return display_js_view_image(dom);
    }
  };

  $(document).ready(function() {
    return $('.js_view_group').each(function() {
      var group_id;
      group_id = $(this).attr('data-group-id');
      if (group_id) {
        return $(this).colorbox({
          rel: group_id,
          transition: "fade"
        });
      }
    });
  });

}).call(this);
