// Generated by CoffeeScript 1.8.0
(function() {
  this.need_sync = false;

  this.keep_sync_binded = false;

  this.sync_per_seconds = 20;

  this.keep_sync = (function(_this) {
    return function() {
      var diff_seconds;
      if (!_this.need_sync) {
        return false;
      } else if (_this.last_sync_at) {
        diff_seconds = _this.sync_per_seconds - (new Date() - _this.last_sync_at) / 1000;
        $('.precess').css('width', 100 * (1 - diff_seconds / _this.sync_per_seconds) + '%');
        if (diff_seconds > 0) {

        } else {
          return _this.save_doc();
        }
      }
    };
  })(this);

  this.hit_sync = (function(_this) {
    return function() {
      if (!_this.keep_sync_binded) {
        _this.keep_sync_binded = true;
        setInterval(_this.keep_sync, 300);
        _this.last_sync_at = new Date();
        _this.need_sync = true;
      }
      if (!_this.need_sync) {
        _this.last_sync_at = new Date();
      }
      _this.need_sync = true;
      return $('#save_button').css('display', 'block');
    };
  })(this);

  this.save_doc = function() {
    var content, doc_path;
    this.need_sync = false;
    $('.precess').css('width', 0);
    $('#save_button a').text('saving...');
    doc_path = $('#doc_path').val();
    content = $.trim($('textarea').val());
    return $.ajax({
      url: '/__file_manager_api',
      method: 'post',
      data: {
        raw_content: content,
        path: doc_path
      },
      success: function(sync_info) {
        $('#save_button').css('display', 'none');
        return $('#save_button a').text('save');
      },
      error: function(error_data) {
        var error_obj;
        error_obj = error_data.responseJSON || error_data.responseText;
        if (typeof error_obj === 'string') {
          return error_obj = JSON.parse(error_obj);
        }
      }
    });
  };

  this.save_doc_by_shortcut = (function(_this) {
    return function() {
      if ($('#save_button').css('display') !== 'none') {
        return _this.save_doc();
      }
    };
  })(this);

  this.fit_textarea = function() {
    var current_width, dom, fixed_width, padding_width, textarea_dom, title_dom, _i, _len, _ref, _results;
    fixed_width = 780;
    current_width = $(window).width();
    padding_width = (current_width - fixed_width) / 2;
    if (padding_width < 15) {
      padding_width = 15;
    }
    textarea_dom = $('textarea');
    title_dom = $('#title');
    _ref = [textarea_dom, title_dom];
    _results = [];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      dom = _ref[_i];
      dom.css('padding-left', padding_width + 'px');
      _results.push(dom.css('padding-right', padding_width + 'px'));
    }
    return _results;
  };

  this.fill_textarea = function() {
    var default_content, header_content, now, textarea_dom;
    textarea_dom = $('textarea');
    default_content = $.trim($(textarea_dom).val());
    if (!default_content) {
      now = new Date();
      header_content = 'title:  ' + $.format.date(now, 'yyyy-MM-dd') + '\ndate: ' + $.format.date(now, 'yyyy-MM-dd HH:mm') + '\n\n';
      textarea_dom.val(header_content);
    }
    return textarea_dom.focus();
  };

  $(document).ready((function(_this) {
    return function() {
      fit_textarea();
      $(window).resize(fit_textarea);
      fill_textarea();
      $('textarea').bind('input propertychange', hit_sync);
      return $(window).keydown(function() {
        var _ref, _ref1;
        if (((_ref = event.which) === 83 || _ref === 115) && (event.ctrlKey || event.metaKey)) {
          event.preventDefault();
          _this.save_doc_by_shortcut();
          return false;
        }
        if (((_ref1 = event.which) === 69 || _ref1 === 101) && (event.ctrlKey || event.metaKey) && window.parent && window.parent.toggle_files_manager) {
          event.preventDefault();
          window.parent.toggle_files_manager();
          return false;
        } else {
          return true;
        }
      });
    };
  })(this));

}).call(this);
