# coding: utf8
api_templates = {
    "feed": "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n{{ response.set_content_type('application/xml') }}\n\n<feed xmlns=\"http://www.w3.org/2005/Atom\">\n  <title>{{ site.title }}</title>\n\n  <description>{{ site.configs.description.escaped }}</description>\n\n  <link href=\"http://{{ request.host }}/\"></link>\n\n  <link ref=\"self\" href=\"http://{{ request.host }}/feed\"></link>\n\n  <id>{{ site._id }}</id>\n{% set feed_posts = posts.get_recent(10) %}\n{% if  feed_posts %}\n  <updated>{{ feed_posts[0]['date'].strftime('%Y-%m-%dT%H:%M:%SZ') }}</updated>\n\n{% endif %}{% for post in feed_posts %}\n  <entry>\n{% set post_url = request.protocol + '://' + request.host + post.url.escaped %}\n\n    <title>{{ post.title.escaped }}</title>\n\n    <link href=\"{{post_url}}\"  rel=\"alternate\"></link>\n\n    <updated>{{ post.date.strftime('%Y-%m-%dT%H:%M:%SZ') }}</updated>\n    <id>{{ post.url_path.escaped }}</id>\n\n    <author>\n      <name>{{ site.author or site.admin_name or site.title }}</name>\n\n    </author>\n    <summary type=\"html\">{{ post.content.escaped }}</summary>\n\n  </entry>\n\n{% endfor %}\n</feed>", 
    "comment": "{% set comment_id = '' if site.configs.comments_type == 'line' else comment.id %}\n\n<li id=\"{{comment_id}}\"  class=\"comment\">\n  <div class=\"comment_wrapper\">\n    <div class=\"author\">\n      <div class=\"avatar\"><img src=\"{{comment.avatar}}\" />\n\n      </div>\n\n      <div class=\"author-name\">{% if  comment.site %}<a href=\"{{comment.site or '#'}}\" rel=\"external nofollow\"><b>{{ comment.author }}</b>\n</a>\n{% else %}<b>{{ comment.author }}</b>\n\n{% endif %}\n<a href=\"javascript:void(0)\" onclick=\"{{\"reply_comment('%s', '%s')\"%(comment.author, comment_id)}}\"  class=\"reply\">reply</a>\n\n      </div>\n\n      <div class=\"author-date\"><small>{{ comment.date(\"%Y-%m-%d %H:%M:%S\") }}</small>\n\n      </div>\n\n    </div>\n\n    <div class=\"comment_content\">{{ comment.content.escaped.to_html_with_images }}</div>\n\n  </div>\n\n</li>", 
    "dropbox_bind": "<html>\n  <header>\n    <title>Bind Dropbox</title>\n{{ h.load('/fb_static/pages/page.css') }}\n\n  </header>\n\n  <body>{{ h.i18n('Bind Dropbox', '绑定 Dropbox', 'zh_cn') }}\n{{ h.i18n('Click Here to Bind Dropbox', '点击此处，绑定 Dropbox', 'zh_cn') }}\n{{ h.i18n('Bound Already', '已绑定', 'zh_cn') }}\n{{ h.i18n('Click Here to Unbind', '点击此处解除绑定', 'zh_cn') }}\n{{ h.i18n(\"reset_cursor_info\", \"sometimes you can reset cursor, next time to sync will try to re-get all files, be careful of this operation!!\") }}\n{{ h.i18n(\"reset_cursor_info\", \"有时，你可以重置 Cursor，下次同步的时候会尝试重新获取所有文件，如非必要请勿进行这个操作！！\", \"zh_cn\") }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>{{ h.i18n(\"Bind Dropbox\") }}</h1>\n\n        </div>\n\n        <div class=\"content_container\">{% if  \"cn\" in request.lang %}\n          <p>1. 在 Dropbox 对应的『应用目录』(比如 App/FarBox )下，再创建 (关联时默认会自动创建) 一个名为 <b>{{cloud_site_folder}}</b> 的文件夹（可以修改网站设置的 Cloud Site Folder, 但这是<b>危险的操作</b>，修改后不要轻易再改），里面的数据才会同步到当前 Bucket。</p>\n\n          <p>2. 请悉知，Dropbox 属于第三方应用，未来可能会存在完全不可用的情况；另外，它与 FarBox 2.0 基本结构有些冲突，其同步的友好度可能会存在潜在问题。</p>\n\n          <p>3. 只能处理 Dropbox 单向同步到 FarBox，不会主动推送回 Dropbox；借助了 Dropbox Webhook 的机制来实现同步通知，其它时候不会触发同步的机制。</p>\n\n{% else %}\n          <p>1. Create (will create automatically when connected Dropbox) another sub-folder named <b>{{cloud_site_folder}}</b> (can modify the Cloud Site Folder of the site settings, but this is <b>a dangerous operation</b> and should not be changed easily afterwards) in the Dropbox's corresponding 'App Directory' (`Apps/FarBox` for example) then the data can be synced to current Bucket.</p>\n\n          <p>2. Please be aware that Dropbox is a third-party application and may not be available in the future; in addition, there may be some conflicts cause of the basic structure of FarBox 2.0, and there also may be potential problems when syncing.</p>\n\n          <p>3. Can only handle Dropbox one-way sync to FarBox, will not actively push back to Dropbox; with the Dropbox Webhook mechanism to achieve sync-notifications, other times will not trigger the synchronization mechanism.</p>\n\n{% endif %}\n\n          <p style=\"text-align:center\">{% if  not dropbox_account.refresh_token %}<a href=\"?action=jump\">{{ i18n(\"Click Here to Bind Dropbox\") }}</a>\n\n{% else %}<span>{{ h.i18n(\"Bound Already\") }}</span>\n<a href=\"?action=unbind\">{{ h.i18n(\"Click Here to Unbind\") }}</a>\n\n{% endif %}\n\n          </p>{% if  dropbox_account.account_id %}\n          <p><span>Dropbox Account ID</span>\n<span>{{ dropbox_account.account_id }}</span>\n\n          </p>\n\n{% endif %}\n          <p><span>Current Cursor:</span>\n{% if  not dropbox_cursor %}<span>{{ \"empty\" }}</span>\n\n{% else %}<span>{{ dropbox_cursor.limit(50).plain }}</span>\n\n{% endif %}\n<br/>\n<span>{{ h.i18n(\"reset_cursor_info\") }}</span><br/>\n<a href=\"?action=reset_cursor\">{{ h.i18n(\"Click Here to Reset Cursor\") }}</a>\n          </p>\n{% if  dropbox_account.expires_at %}\n          <p><span>short access token expires at:</span>\n<span>{{ dropbox_account.expires_at }}</span>\n\n          </p>\n\n{% endif %}\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "builtin_theme_knowbase_post": "{% extends \"builtin_theme_knowbase_base.jade\" %}\n\n{% set category = doc.category %}\n\n{% macro show_post_content(post) %}\n\n<div class=\"markdown\">{% if  doc.metadata.refer %}\n{% set refer_doc = d.get_doc(doc.metadata.refer) %}\n{% if  refer_doc and refer_doc.type == 'post' %}\n  <blockquote class=\"refer\">{{ refer_doc.content.plain_html }}</blockquote>\n\n{% endif %}\n{% endif %}\n  <div>{{ p.get_content_with_referred_docs(doc, show_date=False, tag_url_prefix=\"/wiki/tag\", url_prefix=\"/wiki/post\", url_root=wiki_root, hit_url_path=False) }}</div>\n\n</div>\n\n<div class=\"meta\"><span class=\"cell date\">{{ doc.date }}</span>\n{% if  doc.metadata.author %}<span class=\"cell\"><small>from</small>\n<span class=\"author_name\">{{ doc.metadata.author }}</span>\n</span>\n\n{% endif %}\n</div>\n\n{% endmacro %}\n\n{% block title %}\n{% if  not doc %}{{ response.raise_404() }}\n\n{% endif %}\n<title>{{ doc.title }}</title>\n{{ h.load('markdown') }}\n{{ h.load(\"post_preview\") }}\n\n{% endblock %}\n\n\n{% block content %}\n\n{% set is_from_wiki_notes = request.values.source == \"wiki_nodes\" %}\n\n{% set href_target = \"_blank\" if is_from_wiki_notes else \"\" %}\n\n<div class=\"common_page_wrap\">\n  <div class=\"common_page\">\n    <div class=\"common_page_core\">\n      <div id=\"content_header\" class=\"page_header\"><a href=\"/wiki\" target=\"{{href_target}}\"  class=\"homepage\">Home</a>\n<span class=\"split\">></span>\n{% if  category %}{% for parent_category in category.get_parents(wiki_root) %}<a target=\"{{href_target}}\"  href=\"{{parent_category.get_url(\"/wiki/category\", root=wiki_root)}}\"  class=\"parent_category\">{{ parent_category.title }}</a>\n<span class=\"split\">></span>\n\n{% endfor %}<a target=\"{{href_target}}\"  href=\"{{category.get_url(\"/wiki/category\", root=wiki_root)}}\"  class=\"category\">{{ category.title }}</a>\n<span class=\"split\">></span>\n\n{% endif %}<span>{{ doc.title }}</span>\n\n      </div>\n\n      <div class=\"page_body\">\n        <h2 class=\"title\">{{ doc.title }}</h2>\n\n{% set use_toc = doc.toc and doc.metadata.get(\"toc\", True) %}\n{% if  is_from_wiki_notes %}\n{% set use_toc = False %}\n\n{% endif %}{% if  use_toc %}\n{% call pure() %}\n\n{% call pure(1, 0.8, 0.8) %}\n{{ show_post_content(doc) }}\n{% endcall %}\n\n{% call pure(0, 0.2, 0.2) %}\n{{ h.auto_toc(doc) }}\n\n{% endcall %}\n\n{% endcall %}\n\n{% else %}{{ show_post_content(doc) }}\n{% endif %}\n\n{% set referred_back_docs = p.get_referred_back_docs(doc) %}\n{% if  referred_back_docs %}\n        <div class=\"referred_back_docs\">{{ h.i18n(\"Docs Referred to Current:\", \"其它关联到当前文档的：\", \"zh_cn\") }}\n\n          <h4>{{ h.i18n(\"Docs Referred to Current:\") }}</h4>\n\n          <div class=\"referred_back_docs_items\">{% for sub_doc in referred_back_docs %}\n{% set sub_doc_url = d.get_doc_url(sub_doc, url_prefix=\"/wiki/post\", url_root=wiki_root) %}\n<a href=\"{{sub_doc_url}}\" >{{ \"&lt;%s&gt;\"%sub_doc.title }}</a>\n\n{% endfor %}\n          </div>\n\n        </div>\n\n{% endif %}{% if  doc.tags %}\n        <div class=\"tags\"><span class=\"caption\">Tags:</span>\n{% for tag in doc.tags %}<a href=\"{{\"/wiki/tag/%s\"%tag}}\"  target=\"{{href_target}}\" >{{ tag }}</a>\n\n{% endfor %}\n        </div>\n\n{% endif %}{% if  not is_from_wiki_notes %}{{ doc.comments_as_html() }}\n\n{% endif %}\n      </div>\n\n    </div>\n\n  </div>\n\n</div>\n{% if  request.args.keyword %}{{ h.load('jquery') }}\n{{ h.load('/fb_static/lib/mark/jquery.mark.min.js') }}\n\n<script type=\"text/javascript\">$(document).ready(function(){\n    $('.page_body').mark('{{request.args.keyword}}')\n})\n</script>\n{% endif %}\n{% endblock %}", 
    "page_user_admin": "<html>\n  <header>{{ h.mobile_metas }}\n{% if  request.method == 'POST' %}{{ b.login() }}\n\n{% endif %}{% if  request.args.action == 'logout' %}{{ b.logout() }}\n{{ response.redirect('/admin') }}\n\n{% endif %}{{ h.load('/fb_static/pages/page.css') }}\n{% if  b.logined_bucket %}\n    <title>Dashboard</title>\n\n{% else %}\n    <title>Login</title>\n\n{% endif %}\n\n    <style>p {margin: 1.0em 0 2.5em 0}\na {display: inline-block}\n</style>\n  </header>\n\n  <body>{% if  request.args.action == \"logout_all\" %}{{ b.logout_all_devices() }}\n{{ response.redirect('/admin') }}\n\n{% endif %}{% if  b.logined_bucket %}{{ h.i18n(\"System Setup\", \"系统设置\", \"zh_cn\") }}\n{{ h.i18n(\"Invite\", \"邀请\", \"zh_cn\") }}\n{{ h.i18n(\"Change Bucket Date\", \"修改 Bucket 日期\", \"zh_cn\") }}\n{{ h.i18n(\"Logout Current Device\", \"当前设备下登出\", \"zh_cn\") }}\n{{ h.i18n(\"Logout All Devices\", \"登出所有设备\", \"zh_cn\") }}\n{{ h.i18n(\"System Admin Actions:\", \"系统管理员操作：\", \"zh_cn\") }}\n{{ h.i18n(\"Other Actions:\", \"其它操作：\", \"zh_cn\") }}\n{{ h.i18n(\"Bind Domain to Bucket\", \"绑定域名到 Bucket\", \"zh_cn\") }}\n{{ h.i18n(\"Chose Builtin Theme:\", \"选择内置模板：\", \"zh_cn\") }}\n{{ h.i18n(\"Current Logined Bucket:\", \"当前登录的 Bucket:\", \"zh_cn\") }}\n{{ h.i18n(\"Current Node:\", \"当前节点(Node)：\", \"zh_cn\") }}\n{{ h.i18n(\"Token for Client\", \"客户端 Token\", \"zh_cn\") }}\n{{ h.i18n(\"Domain:\", \"域名：\", \"zh_cn\") }}\n{{ h.i18n(\"Bucket Domains:\", \"Bucket 的域名\", \"zh_cn\") }}\n{{ h.i18n(\"Click Here to Show the Token\", \"点击此处显示 Token\", \"zh_cn\") }}\n{{ h.i18n(\"token_note\", \"Show Token for Client? It's very dangerous, this token equals like Private Key itself!\") }}\n{{ h.i18n(\"token_note\", \"显示客户端用的 Token？这是危险的操作，Token 的权限相当于私钥！\", \"zh_cn\") }}\n{{ h.i18n(\"refresh_token\", \"Click Here to Refresh Token (old one will be invalid)\") }}\n{{ h.i18n(\"refresh_token\", \"点击此处刷新 Token (旧的将会无效掉)\", \"zh_cn\") }}\n{{ h.i18n(\"Manage your Files:\", \"管理你的文件：\", \"zh_cn\") }}\n{{ h.i18n(\"File Manager\", \"文件管理器\", \"zh_cn\") }}\n{{ h.i18n(\"Expired Date:\", \"有效期至：\", \"zh_cn\") }}\n{{ h.i18n(\"Extend One Year?\", \"延长一年?\", \"zh_cn\") }}\n{{ h.i18n(\"Web Spiders Allowed:\", \"允许网络爬虫：\", \"zh_cn\") }}\n{{ h.i18n(\"Toggle\", \"切换\", \"zh_cn\") }}\n{{ h.i18n(\"Allowed\", \"允许\", \"zh_cn\") }}\n{{ h.i18n(\"Not Allowed\", \"不允许\", \"zh_cn\") }}\n{{ h.i18n(\"Force HTTPS Redirect:\", \"HTTPS 强制跳转：\", \"zh_cn\") }}\n{{ h.i18n(\"Load Theme from Bucket\", \"从 Bucket 中载入模板\") }}\n{{ h.i18n(\"file_manager_note\", \"Use Command+E or Control+E to toggle File-Manager at the left side\") }}\n{{ h.i18n(\"file_manager_note\", \"使用快捷键 Command+E 或 Control+E 可以切换左侧的文件管理器\", \"zh_cn\") }}\n{{ h.i18n(\"Web Editor\", \"Web 编辑器\") }}\n{{ h.i18n(\"https_note\", \"There is a data transmission risk when through current non-HTTPS connection.\") }}\n{{ h.i18n(\"https_note\", \"当前不处于 HTTPS 的连接状态下，数据存在传输风险，请悉知。\", \"zh_cn\") }}\n{{ h.i18n(\"Site Settings\", \"网站设置\", \"zh_cn\") }}\n{{ h.i18n(\"Site Wiki Settings\", \"网站Wiki设置\", \"zh_cn\") }}\n{{ h.i18n(\"Site:\", \"网站：\", \"zh_cn\") }}\n{{ h.i18n(\"Email:\", \"邮箱：\", \"zh_cn\") }}\n{{ h.i18n(\"Set Email Address\", \"设置邮箱地址\", \"zh_cn\") }}\n{{ h.i18n(\"Usage\", \"用量\", \"zh_cn\") }}\n{{ h.i18n(\"Clients support FarBox:\", \"支持 FarBox 的客户端：\", \"zh_cn\") }}\n{{ h.i18n(\"Background and Avatars\", \"背景图与头像\", \"zh_cn\") }}\n{{ h.i18n(\"Visitor Passwords\", \"访客密码\", \"zh_cn\") }}\n{{ h.i18n(\"bucket_note\", \"FarBox has no account system, one bucket means one site (if the bucket is accessible).\") }}\n{{ h.i18n(\"bucket_note\", \"FarBox 没有账户体系，一个 bucket 相当于一个网站 (如果 bucket 是可访问的)。\", \"zh_cn\") }}\n{{ h.i18n(\"Document:\", \"文档：\", \"zh_cn\") }}\n{{ h.i18n(\"Bind Dropbox\", \"绑定 Dropbox\", \"zh_cn\") }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>Dashboard</h1>\n\n        </div>\n\n        <div class=\"content_container\">{% if  not request.is_https %}\n          <div style=\"text-align: center\">\n            <p style=\"color:red\">{{ h.i18n(\"https_note\") }}</p>\n\n          </div>\n{% endif %}\n          <p><span>{{ h.i18n(\"Current Logined Bucket:\") }}</span>\n<b>{{ b.logined_bucket }}</b>\n<br/>\n<span style=\"font-size:90%;\">{{ h.i18n(\"bucket_note\") }}</span>\n          </p>\n\n          <p><span>{{ h.i18n(\"Expired Date:\") }}</span>\n{% if  b.service_info.expired_date %}<span>{{ b.service_info.expired_date(\"%Y-%m-%d\") }}</span>\n\n{% else %}<span>?</span>\n\n{% endif %}\n{% if  not b.is_in_blacklist %}<a href=\"/__extend_bucket\" style=\"margin-left:10px;\" target=\"_blank\">{{ h.i18n(\"Extend One Year?\") }}</a>\n\n{% endif %}\n          </p>\n\n          <p><span>{{ h.i18n(\"Current Node:\") }}</span>\n<b>{{ b.node }}</b>\n\n          </p>\n\n          <p><span>{{ h.i18n(\"Document:\") }}</span>\n<a href=\"https://doc.farbox.org/\" target=\"_blank\">https://doc.farbox.org/</a>\n\n          </p>\n{% if  request.args.show_token or request.args.refresh_token %}\n          <p><span>{{ h.i18n(\"Token for Client\") }}</span>\n{% if  request.args.refresh_token %}<b>{{ b.refreshed_client_api_token }}</b>\n\n{% else %}<b>{{ b.client_api_token }}</b>\n\n{% endif %}\n<a style=\"margin-left:10px\" href=\"?refresh_token=true\">{{ h.i18n(\"refresh_token\") }}</a>\n\n          </p>\n\n{% else %}\n          <p><span>{{ h.i18n(\"token_note\") }}</span>\n<a style=\"margin-left:10px\" href=\"?show_token=true\">{{ h.i18n(\"Click Here to Show the Token\") }}</a>\n\n          </p>\n\n{% endif %}\n\n          <hr/>\n\n          <p><span>{{ h.i18n(\"Clients support FarBox:\") }}</span>\n<a href=\"https://apps.apple.com/cn/app/metion-notes-for-writing/id1530965242\" style=\"margin-left:15px\" target=\"_blank\">Metion (iPad+iPhone)</a>\n<a href=\"https://markeditor.com\" style=\"margin-left:15px\" target=\"_blank\">MarkEditor (macOS)</a>\n<a href=\"https://markdown.app\" style=\"margin-left:15px\" target=\"_blank\">Markdown.app (macOS)</a>\n\n          </p>\n\n          <hr/>\n\n          <p><span>{{ h.i18n(\"Site:\") }}</span>\n<a href=\"/__site_settings\" style=\"margin-right:15px\" target=\"_blank\">{{ h.i18n(\"Site Settings\") }}</a>\n<a href=\"/__site_json_settings?path=wiki\" style=\"margin-right:15px\" target=\"_blank\">{{ h.i18n(\"Site Wiki Settings\") }}</a>\n<a href=\"/__site_json_settings?path=site_images\" style=\"margin-right:15px\" target=\"_blank\">{{ h.i18n(\"Background and Avatars\") }}</a>\n{% if  is_dropbox_server_valid %}<a href=\"/__dropbox/bind\" style=\"margin-right:15px\" target=\"_blank\">{{ h.i18n(\"Bind Dropbox\") }}</a>\n\n{% endif %}{% if  is_wechat_server_valid %}<a href=\"/__wechat_bind\" style=\"margin-right:15px\" target=\"_blank\">绑定微信发布</a>\n<a href=\"/__site_json_settings?path=wechat\" style=\"margin-right:15px\" target=\"_blank\">微信发布的设定</a>\n\n{% endif %}<a href=\"/__site_json_settings?path=visit_passwords\" style=\"margin-right:15px\" target=\"_blank\">{{ h.i18n(\"Visitor Passwords\") }}</a>\n<a href=\"/__bucket_usage\" style=\"margin-right:15px\" target=\"_blank\">{{ h.i18n(\"Usage\") }}</a>\n\n          </p>\n\n          <p><span>{{ h.i18n(\"Manage your Files:\") }}</span>\n<a style=\"margin-right:15px\" href=\"{{'/__file_manager?bucket=%s'%b.logined_bucket}}\"  target=\"_blank\">{{ h.i18n(\"File Manager\")+\"(text)\" }}</a>\n<a style=\"margin-right:15px\" href=\"{{'/__file_manager?bucket=%s&type=full'%b.logined_bucket}}\"  target=\"_blank\">{{ h.i18n(\"File Manager\")+\"(full)\" }}</a>\n<a style=\"margin-right:15px\" href=\"{{'/__web_editor?bucket=%s'%b.logined_bucket}}\"  target=\"_blank\">{{ h.i18n(\"Web Editor\")+\"(text)\" }}</a>\n<br/>\n<span style=\"font-size:90%;\">{{ h.i18n(\"file_manager_note\") }}</span>\n          </p>\n\n          <p>{% if  request.args.set_theme %}{{ bucket.apply_builtin_theme(request.args.set_theme) }}\n\n{% endif %}<span>{{ h.i18n(\"Chose Builtin Theme:\") }}</span>\n{% for theme_key in bucket.builtin_theme_keys %}{% if  theme_key == bucket.current_theme_key %}<a href=\"{{\"?set_theme=%s\"%theme_key}}\"  style=\"padding-right:10px\">{{ theme_key.title()+\"(current)\" }}</a>\n\n{% else %}<a href=\"{{\"?set_theme=%s\"%theme_key}}\"  style=\"padding-right:10px\">{{ theme_key.title() }}</a>\n\n{% endif %}\n\n{% endfor %}<br/>\n<span>...or...</span><a href=\"/__apply_theme\" target=\"_blank\">{{ h.i18n(\"Load Theme from Bucket\") }}</a>\n\n          </p>\n\n          <hr/>\n\n          <p><span>{{ h.i18n(\"Domain:\") }}</span>\n<a href=\"/__bind_domain\">{{ h.i18n(\"Bind Domain to Bucket\") }}</a>\n\n          </p>\n{% if  request.args.action == \"remove_domain\" and request.args.domain %}{{ b.unregister_domain(request.args.domain) }}\n\n{% endif %}{% if  b.domains %}\n          <p><span>{{ h.i18n(\"Bucket Domains:\") }}</span>\n{% for domain in b.domains %}<span style=\"padding:0 10px;\"><span>{{ domain }}</span>\n<a style=\"padding:0 3px;\" href=\"{{\"?action=remove_domain&domain=%s\"%domain}}\" >Unbind</a>\n{% if  not b.is_system_domain(domain) %}<a style=\"padding:0 3px;\" href=\"{{\"/__install_ssl_for_bucket_domain?domain=%s\"%domain}}\" >SSL</a>\n\n{% endif %}</span>\n\n{% endfor %}\n          </p>\n\n{% endif %}\n          <p><span>{{ h.i18n(\"Email:\") }}</span>\n{% if  email: %}<span style=\"padding-left:5px; padding-right:5px\">{{ email }}</span>\n\n{% endif %}<a href=\"/__set_bucket_email\">{{ h.i18n(\"Set Email Address\") }}</a>\n\n          </p>\n\n          <p>{% if  request.values.action == \"toggle_spider\" %}{{ b.toggle_enable_web_robots() }}\n{{ response.redirect(\"/admin\") }}\n\n{% endif %}<span>{{ h.i18n(\"Web Spiders Allowed:\") }}</span>\n<span>{{ h.i18n(\"Allowed\") if b.enable_web_robots else h.i18n(\"Not Allowed\") }}</span>\n<a href=\"?action=toggle_spider\" style=\"margin-left:15px\">{{ h.i18n(\"Toggle\") }}</a>\n\n          </p>\n\n          <p>{% if  request.values.action == \"toggle_https_redirect\" %}{{ b.toggle_enable_https_force_redirect() }}\n{{ response.redirect(\"/admin\") }}\n\n{% endif %}<span>{{ h.i18n(\"Force HTTPS Redirect:\") }}</span>\n<span>{{ \"Yes\" if b.enable_https_force_redirect else \"No\" }}</span>\n<a href=\"?action=toggle_https_redirect\" style=\"margin-left:15px\">{{ h.i18n(\"Toggle\") }}</a>\n\n          </p>\n\n          <hr/>\n\n          <p><span>{{ h.i18n(\"Other Actions:\") }}</span>\n<a href=\"/login?action=logout\">{{ h.i18n(\"Logout Current Device\") }}</a>\n<span style=\"padding:0 10px;\">...or...</span>\n<a href=\"/login?action=logout_all\">{{ h.i18n(\"Logout All Devices\") }}</a>\n\n          </p>\n{% if  show_donation %}\n          <hr/>\n\n          <p style=\"text-align:center\"><a href=\"/__donate\" target=\"_blank\">Donation for FarBox</a>\n\n          </p>\n{% endif %}{% if  b.is_system_admin %}\n          <hr/>\n\n          <p><span>{{ h.i18n(\"System Admin Actions:\") }}</span>\n<a href=\"/admin/system_setup\" style=\"margin-right:25px\" target=\"_blank\">{{ h.i18n(\"System Setup\") }}</a>\n<a href=\"/admin/invite\" style=\"margin-right: 15px\" target=\"_blank\">{{ h.i18n(\"Invite\") }}</a>\n<a href=\"/admin/bucket_date\" style=\"margin-right: 15px\" target=\"_blank\">{{ h.i18n(\"Change Bucket Date\") }}</a>\n<a href=\"/admin/system_bucket_assistant_for_replace\" style=\"margin-right: 15px\" target=\"_blank\">{{ h.i18n(\"System Bucket Replace Assistant\") }}</a>\n\n          </p>\n\n          <p><span>More:</span>\n<a href=\"/admin/buckets_usage\" style=\"margin-right:25px\" target=\"_blank\">Buckets Usage</a>\n<a href=\"/_system/status/db_status\" style=\"margin-right:25px\" target=\"_blank\">DB Status</a>\n<a href=\"/_system/buckets\" style=\"margin-right:25px\" target=\"_blank\">Buckets</a>\n<a href=\"/_system/domains\" style=\"margin-right:25px\" target=\"_blank\">Domains</a>\n<a href=\"/_system/buckets_will_sync_from_remote\" style=\"margin-right:25px\" target=\"_blank\">Buckets Will from Remote</a>\n<a href=\"/admin/bucket_status?bucket=\" style=\"margin-right:25px\" target=\"_blank\">One Bucket Status</a>\n<a href=\"/admin/force_sync_es_for_bucket?bucket=\" style=\"margin-right:25px\" target=\"_blank\">Sync ES Indexes</a>\n<a href=\"/admin/install_py_package\" style=\"margin-right:25px\" target=\"_blank\">Install Python Package</a>\n\n          </p>\n\n{% endif %}\n        </div>\n\n      </div>\n\n    </div>\n\n{% else %}\n    <div class=\"post\">\n      <div class=\"post_body\">{{ h.i18n(\"Login by Private Key\", \"使用私钥进行登录\", \"zh_cn\") }}\n{{ h.i18n(\"Login\", \"登录\", \"zh_cn\") }}\n\n        <div class=\"title_container\">\n          <h1>{{ h.i18n(\"Login by Private Key\") }}</h1>\n\n        </div>\n\n        <div class=\"content_container\">\n          <div style=\"text-align:center\">{% if  \"cn\" in request.lang %}\n            <p>请使用对应 Bucket 的 <b>私钥</b> 进行登录，如果遗失了私钥，将没有任何办法重新取回。</p>\n{% if  not request.is_https %}\n            <p style=\"color:red\">当前不处于 HTTPS 的连接状态下，提交数据存在传输风险，请悉知。</p>\n\n{% endif %}\n{% else %}\n            <P>Please login with the <b>Private Key </b>. If the private key is lost, there will be no way to retrieve it.</P>\n{% if  not request.is_https %}\n            <p style=\"color:red\">There is a data transmission risk when submitting through current non-HTTPS connection.</p>\n\n{% endif %}\n{% endif %}\n\n          </div>\n        </div>\n{{ h.simple_form(\"\", ['private_key(type=text, height=300, title=\"\")'], submit_text=h.i18n(\"Login\")) }}\n\n      </div>\n\n    </div>\n\n{% endif %}\n\n  </body>\n\n</html>", 
    "page_file_text_editor": "<!DOCTYPE html>\n<html>\n{% set doc_path = request.get_offset_path(1) %}\n\n{% set doc = d.get_doc(doc_path) %}\n\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n{{ h.headers }}\n\n    <title>{{ doc.path or doc_path }}</title>\n{{ h.load('/fb_static/pages/text_editor/text_editor.css') }}\n\n  </head>\n\n  <body>\n    <div id=\"main\">\n      <div id=\"editor\"><textarea>{{ doc.raw_content }}</textarea>\n\n      </div>\n\n    </div>\n\n    <div id=\"save_button\" style=\"display:none\"><a href=\"javascript:void(0)\" onclick=\"save_doc()\">Save</a>\n<span class=\"precess\"></span>\n\n    </div>\n\n{% set doc_path = doc.real_path or doc.path or doc_path %}\n\n    <input id=\"doc_path\" type=\"hidden\" value=\"{{doc_path}}\" />\n{{ h.load(\"jquery\") }}\n{{ h.load('/fb_static/lib/jquery.dateFormat-1.0.js') }}\n{{ h.load('/fb_static/pages/text_editor/text_editor.js') }}\n\n  </body>\n\n</html>", 
    "page_admin_install_py_package": "<html>\n  <header>\n    <title>Install Python Package</title>\n{{ h.load('/fb_static/pages/page.css') }}\n\n    <style type=\"text/css\">.simple_form .buttons button { margin:0 10px !important;}\n</style>\n  </header>\n\n  <body>\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>Install Python Package</h1>\n\n        </div>\n\n        <div class=\"content_container\">\n          <div style=\"text-align: center\">{% if  \"cn\" in request.lang %}\n            <p>每一次都会产生一次 Web 服务的重启，请慎重操作！</p>\n{% if  not request.is_https %}\n            <p style=\"color:red\">当前不处于 HTTPS 的连接状态下，提交数据存在传输风险，请悉知。</p>\n\n{% endif %}\n{% else %}\n            <p>Every time you submit, the Web service will restart. Please be careful!</p>\n{% if  not request.is_https %}\n            <p style=\"color:red\">There is a data transmission risk when submitting through current non-HTTPS connection.</p>\n\n{% endif %}\n{% endif %}\n{% if  farbox_bucket_version %}\n            <p><span>Current FarBox Bucket Package Version:</span>\n<span>{{ farbox_bucket_version }}</span>\n\n            </p>\n\n{% endif %}\n          </div>\n{% if  result %}\n          <div>\n            <p><b>Result</b>\n\n            </p>\n            <pre style=\"text-align:left\">{{ result }}</pre>\n\n          </div>\n\n{% endif %}{{ h.simple_form(\"\", ['package_url'],                  submit_text=h.i18n(\"Install\")) }}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n</html>", 
    "page_user_set_bucket_email": "<html>\n  <header>{{ h.mobile_metas }}\n\n    <title>Create Bucket</title>\n{{ h.load('/fb_static/pages/page.css') }}\n\n  </header>\n\n  <body>{{ h.i18n(\"Set Email Address for Bucket\", \"为 Bucket 设置邮箱地址\", \"zh_cn\") }}\n{{ h.i18n(\"Setup\", \"设置\", \"zh_cn\") }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>{{ h.i18n(\"Set Email Address for Bucket\") }}</h1>\n\n        </div>\n\n        <div class=\"content_container\">{% if  \"cn\" in request.lang %}\n          <p>注意: 邮箱地址仅限于收取评论的提醒，并不能通过邮箱地址反向查询 Bucket 等功能；如果使用他人的邮箱地址，造成对方骚扰的，会导致你的 Bucket 被禁用。</p>\n\n{% else %}\n          <p>Note: The email address is limited to receiving comment alerts only, and you can't find the Bucket through the email address; if you use other people's email address and make theme harassed, your Bucket will be disabled.</p>\n\n{% endif %}\n\n{% set data_obj = {\"email\": email} %}\n{{ h.simple_form(\"\", ['email'], data_obj=data_obj, info=info, submit_text=\"Setup\") }}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "page_file_manager": "<!DOCTYPE html>\n<html>\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n\n    <title>FileManager</title>\n{{ h.mobile_metas }}\n{{ h.load('jquery') }}\n{{ h.load('/fb_static/lib/jstree/jstree.min.js') }}\n{{ h.load('/fb_static/lib/jstree/themes/default/style.min.css') }}\n{{ h.load('/fb_static/pages/file_manager/tree.css') }}\n{{ h.load('/fb_static/pages/file_manager/tree.js') }}\n{{ h.load('/fb_static/lib/pure.css') }}\n{{ h.load('/fb_static/lib/jquery.modal.css') }}\n{{ h.load('/fb_static/lib/jquery.modal.js') }}\n{{ h.load('/fb_static/lib/jquery.contextMenu.css') }}\n{{ h.load('/fb_static/lib/jquery.contextMenu.js') }}\n\n  </head>\n\n  <body>\n    <input id=\"current_folder\" value=\"\" type=\"hidden\"/>\n\n    <input id=\"current_file\" value=\"\" type=\"hidden\"/>\n\n    <div id=\"new_file\" style=\"display:none;\">{{ h.simple_form(\"New File\", 'name', submit_text='Create') }}\n\n      <p style=\"margin-top:5px;color:#555;font-size:12px;text-align:center\">supports .jade .js .coffee .scss .sass .less .md .txt .markdown .mk .html .xml .csv</p>\n\n    </div>\n\n    <div id=\"new_folder\" style=\"display:none;\">{{ h.simple_form(\"New Folder\", 'name', submit_text='Create') }}\n\n      <p style=\"margin-top:5px;color:#555;font-size:12px;text-align:center\">`rename` is not allowed yet.</p>\n\n    </div>\n\n    <div id=\"main\" class=\"pure-g\">\n      <div class=\"pure-u-4-24 manager_body_part column\">\n        <div class=\"column_body column_left\">\n          <div id=\"folders\"></div>\n\n        </div>\n\n      </div>\n\n      <div class=\"pure-u-5-24 manager_body_part column\">\n        <div class=\"column_body files_container\">\n          <div id=\"files\"></div>\n\n          <div id=\"files_info\">uploading now...</div>\n\n        </div>\n\n      </div>\n\n      <div class=\"pure-u-15-24 manager_editor column\">\n        <div class=\"column_body column_right\">\n          <div id=\"container\">\n            <div class=\"iframe_notes\">\n              <p>welcome</p>\n\n              <p>right-click a folder to create new sub-folder or files</p>\n\n              <p>click a file to edit or preview</p>\n\n              <p>:)</p>\n\n            </div>\n\n            <iframe src=\"\"></iframe>\n\n          </div>\n\n        </div>\n\n      </div>\n\n    </div>\n\n{% set excludes_for_get_data = [] if request.values.type == \"full\" else [\"_\", \"configs\", \"licenses\"] %}\n\n{% set categories = d.get_data(type='folder', limit=1000, excludes=excludes_for_get_data) %}\n\n{% set categories = d.sort_by_position(categories) %}\n{% for category in categories %}{{ set_property(category, \"text\",  category.filename or category.title) }}\n{{ set_property(category, \"a_attr\",  {'href': '/__file_info/'+category['path']+'?bucket=%s'%request.values.bucket, 'path': category['path']}) }}\n\n{% endfor %}\n{% set categories = d.make_tree(categories) %}\n\n{% set root_obj = {'text': '~', 'a_attr':{'href':'/__file_info?bucket=%s'%request.values.bucket}, 'path': ''} %}\n{{ categories.insert(root_obj, position=0) }}\n\n    <script>var core_data = {{ categories.json }};\nvar tree = $('#folders').jstree({\n    'core' : {'data' : core_data, \"check_callback\" : true},\n    \"plugins\": [\"contextmenu\"],\n    \"contextmenu\": {items: folder_context_menu_items}\n     })\n\n\n</script>\n  </body>\n\n</html>", 
    "page_admin_invite": "<!DOCTYPE html>\n<html>\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n\n    <title>Invitations</title>\n{{ h.load('/fb_static/basic/simple_list.css') }}\n\n    <style>.core p a { margin-right: 20px;}\n</style>\n  </head>\n\n  <body>\n    <div class=\"core\">\n      <p style=\"text-align:center;border-bottom:1px dashed #eee; height: 50px; line-height:50px;margin-bottom:70px;\"><a href=\"?action=create&number=1\">Create 1 Invitation</a>\n<a href=\"?action=create&number=3\">Create 3 Invitations</a>\n<a href=\"?action=create&number=10\">Create 10 Invitations</a>\n<a href=\"?action=create&number=1&years=1\">Create 1-year-Inv</a>\n<a href=\"?action=create&number=1&years=3\">Create 3-years-Inv</a>\n<a href=\"?action=create&number=1&years=10\">Create 10-years-Inv</a>\n\n      </p>\n\n      <div class=\"simple_list\">{% for invitation in invitations %}\n        <div class=\"list_item\"><b>{{ invitation._id }}</b>\n\n          <div class=\"info\"><span class=\"sub_info\">created:</span>\n<span>{{ invitation.created_at.date(\"%Y-%m-%d %H:%M:%S\") }}</span>\n{% if  invitation.used_at %}<span class=\"sub_info\">used:</span>\n<span>{{ invitation.bucket+\"@\"+invitation.used_at.date(\"%Y-%m-%d %H:%M:%S\") }}</span>\n\n{% endif %}{% if  invitation.years %}<span class=\"sub_info\">{{ \"%s years\"%invitation.years }}</span>\n\n{% endif %}{% if  invitation.note %}<span class=\"sub_info\">note:</span>\n<span>{{ invitation.note }}</span>\n\n{% endif %}\n          </div>\n\n        </div>\n\n{% endfor %}\n      </div>\n\n    </div>\n\n  </body>\n</html>", 
    "page_admin_system_setup": "<html>\n  <header>\n    <title>System Setup</title>\n{{ h.load('/fb_static/pages/page.css') }}\n\n    <style type=\"text/css\">.simple_form .buttons button { margin:0 10px !important;}\n</style>\n  </header>\n\n  <body>{{ h.i18n('Setup', '设置', 'zh_cn') }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>System Setup for Admin</h1>\n\n        </div>\n\n        <div class=\"content_container\">\n          <div style=\"text-align: center\">{% if  \"cn\" in request.lang %}\n            <p>每一次保存系统设置，都会产生一次 Web 服务的重启，请慎重操作！</p>\n{% if  not request.is_https %}\n            <p style=\"color:red\">当前不处于 HTTPS 的连接状态下，提交数据存在传输风险，请悉知。</p>\n\n{% endif %}\n{% else %}\n            <p>Every time you submit the system Settings, the Web service will restart. Please be careful!</p>\n{% if  not request.is_https %}\n            <p style=\"color:red\">There is a data transmission risk when submitting through current non-HTTPS connection.</p>\n\n{% endif %}\n{% endif %}\n\n          </div>{{ h.simple_form(\"\", ['utc_offset(default=8)', 'endpoint_password', 'server_sync_token', 'server_sync_nodes','should_sync_buckets_in_backend(type=bool, default=False, title=\"Backend Sync\")',                 'elasticsearch_memory(placeholder=\"ends with m/g like 128m or 2g\")', 'free_days(default=30)', 'show_expired_note(type=bool, default=true)', 'show_donation(type=bool, default=true)',                 'bucket_price(default=128)', 'bucket_price2(default=199)', 'node', 'server_secret_key', 'server_api_token', 'site_domains(title=\"WebSite Domains\")',                 'domains(title=\"Domains Provider\")', 'admin_domain_password(title=\"Domain Password\")', 'sentry', 'ses_id(placeholder=\"Amazon SES for Email Notification\")', 'ses_key', 'ses_sender(placeholder=\"Name<no-reply@your-ses-verified-domain.com>\")',                 'wechat_app_id', 'wechat_app_secret', 'wechat_app_id2', 'wechat_app_secret2', 'wechat_token', 'wechat_account_url', 'wechat_account_url2',                 'dropbox_app_key', 'dropbox_app_secret',                 'qcloud_region', 'qcloud_bucket', 'qcloud_secret_id', 'qcloud_secret_key', 'qcloud_url', 'static_files_url', 'qcloud_cdn_token',                 'alipay_pid', 'alipay_public_key(type=text, height=100)', 'alipay_private_key(type=text, height=200)',                 'domain_ssl_key(type=text, height=200)', 'domain_ssl_cert(type=text, height=200)', 'register_note(type=text, height=200)', 'bucket_price_note(type=text, height=200)', 'blacklist(type=text, height=300)'],                  submit_text=h.i18n(\"Setup\"), info=info, data_obj=data_obj) }}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "page_user_bind_domain": "<html>\n  <header>\n    <title>Bind Domain</title>\n{{ h.mobile_metas }}\n{{ h.load('/fb_static/pages/page.css') }}\n\n    <style type=\"text/css\">.simple_form .buttons button { margin:0 10px !important;}\n</style>\n  </header>\n\n  <body>{{ h.i18n('Domain', '域名', 'zh_cn') }}\n{{ h.i18n('Bind Domain', '绑定域名', 'zh_cn') }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>{{ h.i18n(\"Bind Domain\") }}</h1>\n\n        </div>\n\n        <div class=\"content_container\">{% if  \"cn\" in request.lang %}\n          <p><b>绑定独立域名之前，请确保下面的 DNS 记录已经生效:</b>\n\n          </p>\n          <p><span>1， 域名的 A 记录指向 <b>{{ip}}</b></span>\n\n          </p>\n          <p><span>2， 增加域名的 TXT 记录，值为 <b>{{b.logined_bucket}}</b></span>\n\n          </p>{% if  main_domain %}\n          <p><span>3， 如果是 <b>xxx.{{main_domain}}</b> 类似的系统提供的二级域名，不需要设置 DNS 记录</span>\n\n          </p>\n{% endif %}\n          <p><span>注意：当你在自己域名服务商的 DNS 上修改记录后，可能要等上几分钟，甚至一两天记录才会最终生效。</span>\n\n          </p>\n{% else %}\n          <p><b>Before bind a independent domain, make sure the DNS records bellow have taken effect:</b>\n\n          </p>\n          <p><span>1, A record point to <b>{{ip}}</b></span>\n\n          </p>\n          <p><span>2, The value of TXT record is <b>{{b.logined_bucket or \"bucket not login yet\"}}</b></span>\n\n          </p>{% if  main_domain %}\n          <p><span>3, if a sub-domain like <b>xxx.{{main_domain}}</b> that provided by system, no need to set DNS records.</span>\n\n          </p>\n{% endif %}\n          <p><span>Note: When you change the records DNS (service provided by the domain registrar), before finally taken effect it may take a few minutes, or even one day.</span>\n\n          </p>\n{% endif %}\n{% if  request.method == \"POST\" %}\n{% set info = b.register_domain(request.values.domain, request.values.domain_password) %}\n{% if  not info %}{{ response.redirect(\"/admin\") }}\n\n{% endif %}\n{% endif %}{{ h.simple_form(\"\", ['domain(type=input, title=\"Domain\")'], submit_text=h.i18n(\"Bind Domain\"), info=info) }}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "auto_toc": "{% if  post.toc %}{{ h.load('/fb_static/api/html/auto_toc/auto_toc.css') }}\n\n{% set fixed_top = fixed_top or 10 %}\n\n<style type=\"text/css\">{{ \".doc_toc_container.affix{ top: %spx }\"%fixed_top }}</style>\n{% if  top %}\n<script>{{ \"var toc_offset_top=%s\"%top }}</script>\n\n{% endif %}\n<div class=\"doc_toc\">\n  <div class=\"doc_toc_container\">{% if  toc_header %}{{ toc_header }}\n\n{% endif %}\n    <div class=\"nav\">{{ post.toc }}</div>\n\n  </div>\n\n</div>\n{{ h.load('jquery') }}\n{{ h.load('/fb_static/api/html/auto_toc/affix.js') }}\n{{ h.load('/fb_static/api/html/auto_toc/scrollspy.js') }}\n{{ h.load('/fb_static/api/html/auto_toc/auto_toc.js') }}\n\n{% endif %}", 
    "site_visitor_password": "<!DOCTYPE html>\n<html>\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n\n    <title>Protected Site</title>\n\n  </head>\n  <body>\n    <style type=\"text/css\">h1 {\n    text-align: center;\n    margin: 50px auto 80px auto;\n    font-weight: normal;\n    color: #111;\n    font-size: 38px;\n}\nform {\n    text-align: center;\n}\ninput {\n    height: 25px;\n    width: 210px;\n    margin-right: 45px;\n    padding: 3px 5px;\n    font-size: 14px;\n}\n.button {\n    width: 70px;\n}\n</style>\n  </body>\n\n  <h1>Current Site Needs Password to Access</h1>\n\n  <form method=\"post\" action=\"?before_request_check_type=site_visitor_password\">\n    <input type=\"password\" name=\"password\" placeholder=\"Visitor Password\" class=\"password\"/>\n\n    <input type=\"submit\" value=\"Submit\" class=\"button\"/>\n\n  </form>\n\n</html>", 
    "page_file_view": "<!DOCTYPE html>\n{% set filepath = request.get_offset_path(1) %}\n\n<html>\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n\n    <title>{{ filepath }}</title>\n\n  </head>\n  <body>\n    <style>img{ max-width: 100%;}\n</style>\n{% set file_url = '/'+filepath.strip('/') %}\n{% if  request.mime_type.startswith('image/') %}<img src=\"{{file_url}}\" />\n\n{% elif  filepath == 'nav.json' %}{{ response.redirect('/__file_site_nav'+'?bucket=%s'%request.values.bucket) }}\n\n{% elif  request.ext in ['js', 'coffee', 'less', 'scss', 'sass', 'css', 'jade', 'json'] %}{{ response.redirect('/__file_code_editor'+file_url+'?bucket=%s'%request.values.bucket) }}\n\n{% elif  request.ext in ['html', 'htm'] %}{{ response.redirect('/__file_code_editor'+file_url+'?bucket=%s'%request.values.bucket) }}\n\n{% elif  request.ext in ['txt', 'md'] %}{% if  '.comments.' in file_url %}{{ response.response(\"FarBox Comments File is not allowed to display\") }}\n\n{% else %}{{ response.redirect('/__file_text_editor'+file_url+'?bucket=%s'%request.values.bucket) }}\n\n{% endif %}\n\n{% elif  request.mime_type in ['application/markdown', 'text/plain'] %}{% if  '.comments.' in file_url %}{{ response.response(\"FarBox Comments File is not allowed to display\") }}\n\n{% else %}{{ response.redirect('/__file_code_editor'+file_url+'?bucket=%s'%request.values.bucket) }}\n\n{% endif %}\n\n{% elif  request.mime_type in ['text/csv'] %}{{ response.redirect('/__file_csv_editor'+file_url+'?bucket=%s'%request.values.bucket) }}\n\n{% elif  request.mime_type in ['text/html'] and not file_url.startswith('/template/') %}{{ response.redirect(file_url) }}\n\n{% else %}\n    <p>{{ filepath }}</p>\n\n{% endif %}\n\n  </body>\n\n</html>", 
    "paginator": "{% set paginator_style = paginator_style or 'simple' %}\n\n{% set paginator_css_class = 'paginator pager pagination' %}\n{% if  not paginator.has_pre and not paginator.has_next %}\n{% set paginator_css_class = paginator_css_class + \" no_pages\" %}\n\n{% endif %}\n<div class=\"{{paginator_css_class}}\" >\n  <div class=\"paginator_container pagination_container\">{% if  paginator.has_pre or paginator.has_next %}{% if  paginator_style == 'auto' %}{% if  max_count %}{{ paginator.set_default_max_page_numbers(max_count) }}\n\n{% endif %}\n{% set omission_mark = omission_mark or '...' %}\n{% for page_number in paginator.page_numbers %}{% if  page_number %}\n{% set is_current = True if paginator.page==page_number else False %}\n<a href=\"{{paginator.get_page_url(page_number)}}\"  class=\"{{'current' if is_current else ''}}\" >{{ page_number }}</a>\n\n{% else %}<span class=\"fill\">{{ omission_mark }}</span>\n\n{% endif %}\n\n{% endfor %}\n{% elif  paginator_style == 'mini' %}\n{% set max_count = max_count or 5 %}\n{% if  max_count < 3 %}\n{% set max_count = 3 %}\n\n{% endif %}{% if  max_count > 20 %}\n{% set max_count = 20 %}\n\n{% endif %}\n{% set middle_count = (max_count/2).int %}\n{% if  paginator.page <= middle_count %}\n{% set page_begin = 1 %}\n\n{% else %}\n{% set page_begin = paginator.page - middle_count %}\n\n{% endif %}\n{% if  paginator.page + middle_count + 1 > paginator.total_pages %}\n{% set page_end = paginator.total_pages + 1 %}\n\n{% else %}\n{% set page_end = paginator.page + middle_count + 1 %}\n\n{% endif %}\n{% if  paginator.has_pre %}<a href=\"{{paginator.pre_page_url}}\"  rel=\"prev\" class=\"prev\">{{ pre_label }}</a>\n\n{% endif %}{% for page in range(page_begin, page_end) %}\n{% set a_class = 'page-number current' if page==paginator.page else 'page-number' %}\n<a href=\"{{paginator.get_page_url(page)}}\"  class=\"{{a_class}}\" >{{ page }}</a>\n\n{% endfor %}{% if  paginator.has_next %}<a href=\"{{paginator.next_page_url}}\"  rel=\"next\" class=\"next\">{{ next_label }}</a>\n\n{% endif %}\n{% else %}{% if  paginator.has_pre %}<a href=\"{{paginator.pre_url}}\"  class=\"btn pre newer-posts newer_posts\">{{ pre_label }}</a>\n\n{% endif %}{% if  show_page_of %}<span class=\"page_number page-number\">{{ 'Page %s of %s' % (paginator.page, paginator.pages) }}</span>\n\n{% endif %}{% if  paginator.has_next %}<a href=\"{{paginator.next_url}}\"  class=\"btn next older-posts older_posts\">{{ next_label }}</a>\n\n{% endif %}\n{% endif %}\n\n    <div style=\"clear:both;height:0;\"></div>\n\n{% endif %}\n  </div>\n\n</div>", 
    "builtin_theme_album_waterfall": "<!DOCTYPE html>\n<html>\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n\n    <title>{{ site.albums_title or \"Album\" }}</title>\n{{ h.headers }}\n{{ h.load(\"/fb_static/builtin_themes/waterfall/style.css\") }}\n{{ h.load(\"/fb_static/builtin_themes/waterfall/responsive_waterfall.js\") }}\n\n  </head>\n\n  <body>{{ site.nav }}\n\n    <h1>{{ page_title or \"Album\" }}</h1>\n\n{% call page(dom_id='waterfall') %}\n{% for doc in docs %}{% if  doc.type == 'folder' %}\n{% set cover = doc.cover %}\n\n{% set url = doc.album_url %}\n\n{% set item_class = 'item album_item' %}\n\n{% else %}\n{% set cover = doc.url %}\n\n{% set url = doc.url %}\n\n{% set item_class = 'item' %}\n\n{% endif %}\n\n{% set cover = cover.resize(width=600) %}\n\n    <div class=\"{{item_class}}\" >\n      <div class=\"item_body\">{{ h.auto_a(title=cover, href=url, alt=doc.title) }}\n\n        <div class=\"description\"><span class=\"title\">{{ doc.title }}</span>\n{% if  doc.type == 'folder' %}<span class=\"images_count\">{{ \"(%s)\"%doc.images_count }}</span>\n\n{% else %}<span class=\"date\">{{ doc.date }}</span>\n\n{% endif %}\n\n        </div>\n{% if  doc.type == 'folder' %}<span class=\"album_label\">{{ '≡' }}</span>\n\n{% endif %}\n      </div>\n\n    </div>\n{% endfor %}\n{% endcall %}\n{{ h.load(\"jquery\") }}\n{{ h.load(\"/fb_static/builtin_themes/waterfall/script.js\") }}\n\n  </body>\n\n</html>", 
    "page_user_usage": "<html>\n  <header>{{ h.mobile_metas }}\n\n    <title>Bucket Usage</title>\n{{ h.load('/fb_static/pages/page.css') }}\n{{ h.load('/fb_static/pages/table.css') }}\n\n  </header>\n\n  <body>{{ h.i18n(\"Usage\", \"用量统计\", \"zh_cn\") }}\n{{ h.i18n(\"Bandwidth\", \"流量\", \"zh_cn\") }}\n{{ h.i18n(\"Requests\", \"请求数\", \"zh_cn\") }}\n{{ h.i18n(\"note\", \"The usage statistics are relatively rough and may not be accurate, for reference only.\") }}\n{{ h.i18n(\"note\", \"注意：用量统计比较粗略，或许并不精准，仅供参考。\", \"zh_cn\") }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>{{ h.i18n(\"Usage\") }}</h1>\n\n        </div>\n\n        <div class=\"content_container\">\n          <h2><span>{{ usage.file_size }}</span>\n<small>(storage)</small>\n<span style=\"margin-left:10px;\">{{ usage.docs_count }}</span>\n<small>(records)</small>\n\n          </h2>\n\n          <p><span>`records` includes some types like:</span>\n{% for field in [\"post\", \"image\", \"folder\", \"file\"] %}<span style=\"margin-right:10px\"><b>{{ field }}</b>\n<small>{{ \"(%s)\" % (usage.get(\"%ss_count\"%field) or 0) }}</small>\n</span>\n\n{% endfor %}\n          </p>\n\n          <p>{{ h.i18n(\"note\") }}</p>\n\n          <hr/>\n\n          <h2>{{ h.i18n(\"Bandwidth\") }}</h2>\n          <table class=\"usage\">\n            <thead>\n              <tr>\n                <th>Month</th>\n\n                <th>Bandwidth</th>\n\n              </tr>\n\n            </thead>\n\n            <tbody>{% for u in usage.bandwidth %}\n              <tr>\n                <td>{{ u.month }}</td>\n\n                <td>{{ u.value }}</td>\n\n              </tr>\n\n{% endfor %}\n            </tbody>\n          </table>\n\n          <hr/>\n\n          <h2>{{ h.i18n(\"Requests\") }}</h2>\n          <table class=\"usage\">\n            <thead>\n              <tr>\n                <th>Month</th>\n\n                <th>Requests</th>\n\n              </tr>\n\n            </thead>\n\n            <tbody>{% for u in usage.requests %}\n              <tr>\n                <td>{{ u.month }}</td>\n\n                <td>{{ u.value }}</td>\n\n              </tr>\n\n{% endfor %}\n            </tbody>\n          </table>\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "api_slider": "{{ h.load(\"jquery\") }}\n{{ h.load(\"/fb_static/lib/unslider/css/unslider.css\") }}\n{{ h.load(\"/fb_static/lib/unslider/css/unslider-dots.css\") }}\n{{ h.load(\"/fb_static/lib/unslider/js/unslider-min.js\") }}\n{{ h.load(\"/fb_static/api/syntax/slider/slider.css\") }}\n{{ h.load(\"/fb_static/api/syntax/slider/slider.js\") }}\n\n<style type=\"text/css\">{{ block_css_style }}</style>\n\n<div id=\"{{dom_id}}\" >\n  <div data-autoplay=\"{{'true' if autoplay else ''}}\"  data-show-arrows=\"{{'true' if show_arrows else ''}}\"  data-animation=\"{{animation or ''}}\"  class=\"bitcron_slider\">\n    <ul>{% for element in elements %}\n      <li>{{ element }}</li>\n\n{% endfor %}\n    </ul>\n  </div>\n\n</div>", 
    "builtin_theme_knowbase_index": "{% extends \"builtin_theme_knowbase_base.jade\" %}\n\n{% block content %}\n{{ h.load('font') }}\n\n<style>.header {height: 300px;}\n.header #search_bar {top:100px;}\n\n</style>\n<div class=\"homepage_categories\">\n{% call pure() %}\n{% for doc in docs %}\n{% call pure(1, 0.5, 0.3333, 0.3333) %}\n\n{% set summary = doc.summary or doc.metadata.summary or '' %}\n\n{% set icon_class = doc.icon or doc.metadata.icon or 'fa fa-heart-o' %}\n{% if  summary %}\n{% set dom_class = 'category with_summary' %}\n\n{% else %}\n{% set dom_class = 'category without_summary' %}\n\n{% endif %}\n<a href=\"{{\"%s#main\"%doc.wiki_url}}\"  class=\"{{dom_class}}\" >\n    <div class=\"category_body\"><i class=\"{{icon_class+' icon'}}\" ></i>\n\n      <h2>{{ doc.title }}</h2>{% if  summary %}\n      <p class=\"summary\">{{ summary }}</p>\n\n{% endif %}\n    </div>\n</a>\n{% endcall %}\n\n{% endfor %}{% if  wiki_configs.get('header_animation', True) %}{{ h.load('jquery') }}\n{{ h.load('/fb_static/builtin_themes/knowbase/particles.js') }}\n{{ h.load('/fb_static/builtin_themes/knowbase/run_particles.js') }}\n\n{% endif %}\n{% endcall %}\n\n</div>\n\n{% endblock %}", 
    "page_file_code_editor": "<!DOCTYPE html>\n<html>\n{% set doc_path = request.get_offset_path(1) %}\n\n{% set doc = d.get_doc(doc_path) %}\n\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n\n    <title>{{ doc.path or doc_path }}</title>\n{{ h.load('/fb_static/pages/code_editor/editor.css') }}\n{{ h.load('jquery') }}\n{{ h.load('/fb_static/pages/code_editor/codemirror/codemirror.css') }}\n{{ h.load('/fb_static/pages/code_editor/codemirror/solarized.css') }}\n{{ h.load('/fb_static/pages/code_editor/codemirror/codemirror.js') }}\n{{ h.load('/fb_static/pages/code_editor/codemirror/mode/jade.js') }}\n{{ h.load('/fb_static/pages/code_editor/codemirror/mode/css.js') }}\n{{ h.load('/fb_static/pages/code_editor/codemirror/mode/xml.js') }}\n{{ h.load('/fb_static/pages/code_editor/codemirror/mode/javascript.js') }}\n{{ h.load('/fb_static/pages/code_editor/codemirror/mode/coffeescript.js') }}\n{{ h.load('/fb_static/pages/code_editor/codemirror/mode/markdown.js') }}\n{{ h.load('/fb_static/pages/code_editor/codemirror/mode/htmlmixed.js') }}\n{{ h.load('/fb_static/pages/code_editor/editor.js') }}\n\n  </head>\n\n  <body>{% if  request.ext in ['txt', 'md', 'markdown', 'mk'] %}\n    <style>.CodeMirror-sizer {min-width: auto !important;}\npre.CodeMirror-line{word-wrap: break-word !important; padding: 0 12px !important;}\n#editor{\n    font-family: \"Hiragino Sans GB\", \"Microsoft Yahei\", Verdana, Arial, sans-serif;\n    font-size: 14px;\n    line-height: 2.1em;\n}\n</style>\n{% endif %}\n    <div id=\"editor\"></div>\n\n    <div id=\"save_button\" style=\"display:none\"><a href=\"javascript:void(0)\" onclick=\"save_doc()\">Save</a>\n<span class=\"precess\"></span>\n\n    </div>\n\n{% set doc_path = doc.real_path or doc.path or doc_path %}\n\n    <input id=\"doc_path\" type=\"hidden\" value=\"{{doc_path}}\" />\n{% if  doc.type == 'comments' %}\n{% set raw_content = \"not allowed content type, do not edit it! the only thing you can do is delete it!\" %}\n\n{% else %}\n{% set raw_content = doc.raw_content or doc.content %}\n\n{% endif %}\n<textarea id=\"content_container\" style=\"display:none\">{{ raw_content }}</textarea>\n\n  </body>\n\n</html>", 
    "form_simple_form": "{{ h.load(\"/fb_static/api/html/form/simple_form.css\") }}\n{{ h.load(\"/fb_static/lib/wtf-forms.css\") }}\n\n<div class=\"simple_form\">{% if  title %}\n  <h2>{{ _(title) }}</h2>\n\n{% endif %}\n{% set action_url = action_url or request.url %}\n\n  <form method=\"post\" action=\"{{action_url}}\"  target=\"{{target or ''}}\" >{% if  header_html %}{{ header_html }}\n\n{% endif %}\n    <div class=\"simple_fields\">{% for field in fields %}{% if  field.type not in ['hidden'] %}\n      <div class=\"simple_field_wrap\">\n        <div class=\"simple_field\">{{ h.create_form_dom_by_field(field) }}\n\n          <div class=\"clear\"></div>\n\n        </div>\n\n      </div>\n\n{% else %}{{ h.create_form_dom_by_field(field) }}\n\n{% endif %}\n\n{% endfor %}\n    </div>\n{% if  info and info.strip() %}\n    <div class=\"info\"><span id=\"info\">{{ info }}</span>\n\n    </div>\n\n{% endif %}\n    <div class=\"clear\"></div>\n\n    <div class=\"buttons\">{% if  buttons %}{% for button in buttons %}\n      <button type=\"button\">{{ _(button) }}</button>\n\n{% endfor %}\n{% else %}\n{% set button_type = button_type or 'submit' %}\n{% if  disable_button %}\n      <button type=\"{{button_type}}\"  disabled=\"disabled\">{{ _(submit_text or 'Save') }}</button>\n\n{% else %}\n      <button type=\"{{button_type}}\" >{{ _(submit_text or 'Save') }}</button>\n\n{% endif %}\n\n{% endif %}\n\n    </div>\n\n  </form>\n{% if  focus %}\n  <script>var dom_to_focus = document.getElementById(\"{{focus}}\");\nif (dom_to_focus) dom_to_focus.focus();\n</script>\n{% endif %}\n</div>\n{{ h.load(\"essage\") }}\n{{ h.load(\"jquery\") }}\n{{ h.load(\"/fb_static/api/html/form/file_field.js\") }}\n{% if  ajax %}{{ h.ajax_submit() }}\n\n{% endif %}", 
    "page_admin_bucket_usage": "<html>\n  <header>\n    <title>Bucket Usage</title>\n{{ h.load('/fb_static/pages/page.css') }}\n{{ h.load('/fb_static/pages/table.css') }}\n\n  </header>\n\n  <body>{{ h.i18n(\"Usage\", \"用量统计\", \"zh_cn\") }}\n{{ h.i18n(\"Bandwidth\", \"流量\", \"zh_cn\") }}\n{{ h.i18n(\"Requests\", \"请求数\", \"zh_cn\") }}\n{{ h.i18n(\"note\", \"The usage statistics are relatively rough and may not be accurate, for reference only.\") }}\n{{ h.i18n(\"note\", \"注意：用量统计比较粗略，或许并不精准，仅供参考。\", \"zh_cn\") }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>{{ h.i18n(\"Usage\") }}</h1>\n\n        </div>\n\n        <div class=\"content_container\">{% if  domains: %}\n          <h2>Domains</h2>\n\n          <p>{% for domain in domains %}<span style=\"margin-right:10px\">{{ domain }}</span>\n\n{% endfor %}\n          </p>\n{% endif %}\n          <p><span>{{ h.i18n(\"Expired Date:\") }}</span>\n<span>{{ service_info.expired_date(\"%Y-%m-%d\") }}</span>\n\n          </p>\n\n          <h2><span>{{ usage.file_size }}</span>\n<small>(storage)</small>\n<span style=\"margin-left:10px;\">{{ usage.docs_count }}</span>\n<small>(records)</small>\n\n          </h2>\n\n          <p><span>`records` includes some types like:</span>\n{% for field in [\"post\", \"image\", \"folder\", \"file\"] %}<span style=\"margin-right:10px\"><b>{{ field }}</b>\n<small>{{ \"(%s)\" % (usage.get(\"%ss_count\"%field) or 0) }}</small>\n</span>\n\n{% endfor %}\n          </p>\n\n          <p>{{ h.i18n(\"note\") }}</p>\n\n          <hr/>\n\n          <h2>Search Indexes Status</h2>\n          <table>\n            <thead>\n              <tr>\n                <th>Key</th>\n\n                <th>Value</th>\n\n              </tr>\n\n            </thead>\n\n            <tbody>{% for field in [\"db_last_id\", \"es_is_valid\", \"es_cursor\", \"es_count\", \"es_indexes_ok\"] %}\n              <tr>\n                <td>{{ field }}</td>\n\n                <td>{{ es_status.get(field, \"\") }}</td>\n\n              </tr>\n\n{% endfor %}\n            </tbody>\n          </table>\n\n          <hr/>\n\n          <h2>{{ h.i18n(\"Bandwidth\") }}</h2>\n          <table class=\"usage\">\n            <thead>\n              <tr>\n                <th>Month</th>\n\n                <th>Bandwidth</th>\n\n              </tr>\n\n            </thead>\n\n            <tbody>{% for u in usage.bandwidth %}\n              <tr>\n                <td>{{ u.month }}</td>\n\n                <td>{{ u.value }}</td>\n\n              </tr>\n\n{% endfor %}\n            </tbody>\n          </table>\n\n          <hr/>\n\n          <h2>{{ h.i18n(\"Requests\") }}</h2>\n          <table class=\"usage\">\n            <thead>\n              <tr>\n                <th>Month</th>\n\n                <th>Requests</th>\n\n              </tr>\n\n            </thead>\n\n            <tbody>{% for u in usage.requests %}\n              <tr>\n                <td>{{ u.month }}</td>\n\n                <td>{{ u.value }}</td>\n\n              </tr>\n\n{% endfor %}\n            </tbody>\n          </table>\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "comments": "{% macro one_comment(comment) %}\n\n{% set comment_id = '' if site.configs.comments_type == 'line' else comment.id %}\n\n<li id=\"{{comment_id}}\"  class=\"comment\">\n  <div class=\"comment_wrapper\">\n    <div class=\"author\">\n      <div class=\"avatar\"><img src=\"{{comment.avatar}}\" />\n\n      </div>\n\n      <div class=\"author-name\">{% if  comment.site %}<a href=\"{{comment.site or '#'}}\" rel=\"external nofollow\"><b>{{ comment.author }}</b>\n</a>\n{% else %}<b>{{ comment.author }}</b>\n\n{% endif %}\n<a href=\"javascript:void(0)\" onclick=\"{{\"reply_comment('%s', '%s')\"%(comment.author, comment_id)}}\"  class=\"reply\">reply</a>\n\n      </div>\n\n      <div class=\"author-date\"><small>{{ comment.date(\"%Y-%m-%d %H:%M:%S\") }}</small>\n\n      </div>\n\n    </div>\n\n    <div class=\"comment_content\">{{ comment.content.escaped.to_html_with_images }}</div>\n{% if  comment.children and comment.children.is_array %}\n    <ul class=\"sub_comments\">{% for sub_comment in comment.children %}{{ one_comment(sub_comment) }}\n{% endfor %}\n    </ul>\n\n{% endif %}\n  </div>\n\n</li>\n\n{% endmacro %}\n{{ _('Comments', '发表评论', 'zh_cn') }}{{ _('Write a Comment', '撰写评论', 'zh_cn') }}{{ _('Submit!', '提交评论', 'zh_cn') }}{{ _('Name', '昵称', 'zh_cn') }}{{ _('Email', '邮箱', 'zh_cn') }}{{ _('Website', '网站', 'zh_cn') }}{{ h.load('/fb_static/comments/style.css') }}\n\n<div id=\"comments\" class=\"doc_comments\">\n  <div class=\"doc_comments_wrapper\">\n    <div class=\"comments_block_title\">{{ _('Comments') }}</div>\n\n    <div class=\"new_comment_form_container\">\n      <form id=\"new_comment_form\" method=\"post\" action=\"/service/comment/new?bucket={{bucket.current_bucket}}\">\n        <input name=\"path\" type=\"hidden\" value=\"{{doc.path}}\" />\n\n        <input id=\"reply_to_id\" name=\"reply\" type=\"hidden\" value=\"\"/>\n        <div class=\"comment_trigger\">\n          <div class=\"avatar\"><img src=\"{{site.visitor_avatar}}\" />\n\n          </div>\n\n          <div class=\"trigger_title\">{{ _('Write a Comment') }}</div>\n\n        </div>\n\n        <div class=\"new_comment\"><textarea name=\"content\" rows=\"2\" class=\"textarea_box\"></textarea>\n<span class=\"comment_error\"></span>\n\n        </div>\n\n        <div class=\"comment_triggered\">\n          <div class=\"input_body\">{% if  not request.is_login %}\n            <ul class=\"ident\">\n              <li class=\"verification_code\"><img id=\"verification_code_image\" src=\"\"/>\n\n                <input type=\"text\" name=\"verification_code\"/>\n\n              </li>\n\n              <li class=\"li_author\">\n                <input type=\"text\" name=\"author\" placeholder=\"{{_('Name')}}\"  class=\"author_input\"/>\n\n              </li>\n              <li class=\"li_email\">\n                <input type=\"text\" name=\"email\" placeholder=\"{{_('Email')}}\"  class=\"email_input\"/>\n\n              </li>\n              <li class=\"li_site\">\n                <input type=\"text\" name=\"site\" placeholder=\"{{_('Website')}}\"  class=\"site_input\"/>\n\n              </li>\n            </ul>\n\n{% endif %}\n            <input type=\"submit\" value=\"{{_('Submit!')}}\"  class=\"comment_submit_button c_button\"/>\n\n          </div>\n\n        </div>\n\n      </form>\n\n    </div>\n\n    <ul class=\"comments\">{% for comment in doc.comments %}{{ one_comment(comment) }}\n{% endfor %}\n    </ul>\n{{ h.load('jquery') }}\n{{ h.load('/fb_static/lib/js.cookie.js') }}\n{{ h.load('/fb_static/lib/textcomplete/jquery.textcomplete.min.js') }}\n{{ h.load('/fb_static/comments/script.js') }}\n\n    <script>{{ \"var people=%s\" % doc.get_comments_people('').json }}</script>\n\n    <script>$(\".new_comment textarea\").textcomplete([{\n    match: /@(\\S*)$/,\n    search: function(term, callback){\n        callback($.map(people, function(person){\n            return person.indexOf(term)==0 ? person : null\n        }))\n    },\n    replace: function(value){\n        if (value.indexOf(' ')!='-1'){\n            return '@' + value + ', ';\n        }\n        else{\n            return '@' + value + ' ';\n        }\n    },\n    index: 1\n}]);\n</script>\n  </div>\n\n</div>", 
    "api_slider_doc_element": "{% if  doc.type == 'image' %}\n<div style=\"{{\"background-image:url('%s')\" % doc.url}}\"  class=\"slider_element\">{% if  show_image_title %}\n  <div class=\"slider_element_content\">\n    <h3>{{ doc.title }}</h3>\n\n  </div>\n\n{% endif %}\n</div>\n\n{% else %}{{ h.load(\"markdown\") }}\n\n<div class=\"slider_element post_slider_element\">\n  <!-- link or just display?-->\n\n{% set link = doc.metadata.link %}\n\n{% set post_content_class = \"post_content\" if  doc.images else \"post_content post_content_without_images\" %}\n\n  <div class=\"{{post_content_class}}\" >{% if  link %}<a href=\"{{link}}\"  class=\"post_slider_element_link\">\n      <div class=\"markdown\">{{ doc.content }}</div>\n</a>\n\n{% else %}\n    <div class=\"markdown\">{{ doc.content }}</div>\n\n{% endif %}\n\n  </div>\n</div>\n\n{% endif %}", 
    "page_user_install_ssl": "<html>\n  <header>{{ h.mobile_metas }}\n\n    <title>Install SSL for {{request.values.domain}}</title>\n{{ h.load('/fb_static/pages/page.css') }}\n\n  </header>\n\n  <body>{{ h.i18n(\"Install SSl\", \"安装 SSL 证书\", \"zh_cn\") }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>{{ h.i18n(\"Install SSl\") + \" %s\"%request.values.domain }}</h1>\n\n        </div>\n\n        <div class=\"content_container\">{% if  \"cn\" in request.lang %}\n          <p>SSL 安装后如果没有报错，那么基本上就是成功的；但服务端的 SSL 对应有几分钟的缓存，客户端的浏览器也可能存在 SSL 的缓存，请耐心等待最终生效。</p>\n\n          <p>注意： SSL Private Key 是 SSL 自身的私钥，跟 Bucket 是无关的，更不是 Bucket 的私钥。</p>\n\n{% else %}\n          <p>If no errors are reported after Install SSL, it is basically successful; However, SSL would to be cached for a few minutes on the server side, and maybe have the same issue in the client browser too, so please be patient.</p>\n\n          <p>Note: SSL Private Key is not the Private Key of current bucket.</p>\n\n{% endif %}\n{{ h.simple_form(\"\", ['ssl_key(type=text, height=200, title=\"SSL Private Key\")', 'ssl_cert(type=text, height=200, title=\"SSL Cert\")'], data_obj=data_obj, info=info, submit_text=h.i18n(\"Install SSL\")) }}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "search_posts": "{% if  not just_js %}{{ h.i18n(\"Search\", \"搜索\", 'zh_cn') }}\n\n<div id=\"search_bar\">\n{% set search_placeholder = placeholder or _(\"Search\") %}\n\n  <input id=\"search_posts_keywords\" placeholder=\"{{search_placeholder}}\"  type=\"text\" value=\"{{request.args.s}}\" />\n{% if  show_button %}{{ h.load('font') }}\n<a href=\"#\" class=\"search_in_html_button\"><i class=\"fa fa-search\"></i>\n</a>\n\n{% endif %}\n</div>\n\n{% endif %}{{ h.load(\"jquery\") }}\n\n<script>var search_base_url = \"{{ search_base_url or site.root_url or '/' }}\";\nvar search_under = \"{{search_under or site.root_path or ''}}\";\n$(document).ready(function() {\n    var search_posts_dom = $('#search_posts_keywords');\n    search_posts_dom.val(\"{{request.args.s or ''}}\");\n\n    if (location.search.indexOf('?s=') === 0 && search_posts_dom.length) {\n          var old_keywords = search_posts_dom.val();\n          search_posts_dom.focus().val(old_keywords);\n          var keywords_length = old_keywords.length;\n          search_posts_dom[0].setSelectionRange(keywords_length, keywords_length)\n    }\n    var search_posts = function(){\n        var keywords = search_posts_dom.val();\n        var url_to_jump = location.protocol + '//' + location.host + search_base_url + '?s=' + keywords;\n        if (search_under){ url_to_jump += \"&under=\"+search_under}\n        location.href = url_to_jump;\n        return false\n    };\n\n    search_posts_dom.keyup(function(event) {\n          if (event.which === 13) {\n            search_posts()\n          }\n          return false;\n    });\n\n    $('.search_in_html_button').click(search_posts);\n})\n</script>", 
    "page_admin_system_bucket_assistant": "<html>\n  <header>\n    <title>System Setup</title>\n{{ h.load('/fb_static/pages/page.css') }}\n\n    <style type=\"text/css\">.simple_form .buttons button { margin:0 10px !important;}\n</style>\n  </header>\n\n  <body>{{ h.i18n('Setup', '设置', 'zh_cn') }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>System Bucket Assistant</h1>\n\n        </div>\n\n        <div class=\"content_container\">\n          <p>for System Admin only, without getting the private key of user's bucket, but can also sync the data to user's bucket. the relation for REPLACE will expire 20 minutes later. BE CAREFUL!!</p>\n{{ h.simple_form(\"\", ['system_bucket', 'user_bucket'],                  submit_text=h.i18n(\"Setup\"), data_obj=data_obj, info=info) }}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "api_tab": "{{ h.load('jquery') }}\n{{ h.load('/fb_static/lib/jquery.tabslet.min.js') }}\n{{ h.load('/fb_static/api/syntax/tab.css') }}\n\n<div id=\"{{dom_id}}\"  class=\"tabs_set\">\n  <ul class=\"horizontal\">{% for key in keys %}\n{% set tab_selector = '#%s-%s'%(dom_id, loop.index0) %}\n\n    <li><a href=\"{{tab_selector}}\" >{{ key }}</a>\n\n    </li>\n{% endfor %}\n    <div class=\"clear\"></div>\n\n  </ul>\n{{ inner_html }}\n\n</div>\n\n<script>var dom_selector = '#'+'{{dom_id}}';\nvar active = {{active}};\n$(document).ready(function(){\n    $(dom_selector).tabslet({active:active, deeplinking: true})\n});\n</script>", 
    "form_grid_form": "{% if  not without_style %}{{ h.load('pure') }}\n{{ h.load(\"/fb_static/api/html/form/grid_form.css\") }}\n\n{% endif %}\n{% set per_cell = per_cell or 3 %}\n\n{% set lg_per_cell = lg_per_cell or per_cell+1 %}\n\n{% set form_class = 'complex_form' %}\n{% if  for_page %}\n{% set form_class = 'complex_form complex_form_page' %}\n\n{% endif %}\n{% set action_path = request.url_without_host %}\n{% if  form_id %}\n{% set action_path = request.join(action_path, form_id=form_id) %}\n\n{% endif %}\n<form method=\"POST\" action=\"{{action_path}}\"  class=\"{{form_class}}\" >{% if  form_title %}\n  <h2 class=\"form_title\">{{ form_title }}</h2>\n\n{% endif %}\n  <div class=\"form_body\">\n    <div class=\"pure-g pure-form pure-form-stacked fields\">{% for field in fields %}{% if  field.type in ['text','list', 'dom_list'] or field.full_width %}\n{% set field_container_class = 'pure-u-1' %}\n\n{% else %}\n{% set field_container_class = 'pure-u-1 pure-u-md-1-%s pure-u-lg-1-%s' % (per_cell, lg_per_cell) %}\n\n{% endif %}\n{{ h.create_form_dom_by_field(field, field_container_class) }}\n\n{% endfor %}{% if  info %}\n      <div class=\"info\"><span id=\"info\">{{ info }}</span>\n\n      </div>\n\n{% endif %}\n    </div>\n\n  </div>\n\n  <div class=\"pure-g pure-form pure-form-stacked fields\">{% if  not hide_submit_button %}\n    <div class=\"pure-u-1 submit\">\n      <div class=\"submit_body\">\n{% set submit_text = submit_text or _('Save Configs') %}\n\n        <button type=\"submit\" class=\"pure-button pure-input-1-2 pure-button-primary\">{{ submit_text }}</button>\n\n      </div>\n\n    </div>\n\n{% endif %}\n  </div>\n\n</form>\n{% if  ajax %}{{ h.ajax_submit() }}\n\n{% endif %}", 
    "ajax_submit": "{{ h.load('essage') }}\n{{ h.load('jquery') }}\n{{ h.load(\"/fb_static/lib/jquery.form.js\") }}\n{{ h.load(\"/fb_static/api/html/form/ajax_submit.js\") }}\n{% if  re_install %}\n<script>install_ajax_submit();\n</script>\n{% endif %}", 
    "page_web_editor_posts": "{{ set_property(response, \"type\",  'application/json') }}\n\n{% set posts = d.get_data(type='post', status='all', limit=150, sort='-date', excludes='_') %}\n{{ posts.json }}", 
    "page_admin_default_homepage": "<!DOCTYPE html>\n<html>\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n{{ html.load('pure') }}\n{{ html.load('/fb_static/pages/default_homepage/cover.css') }}\n{{ html.load('/fb_static/pages/default_homepage/style.css') }}\n{{ html.mobile_metas }}\n\n    <title>FarBox</title>\n\n  </head>\n\n  <body>{{ h.i18n(\"description\", \"Humans create the contents, we render them\") }}\n{{ h.i18n(\"description\", \"人类创造内容，我们负责渲染\", \"zh_cn\") }}\n{{ h.i18n(\"Register\", \"注册\", \"zh_cn\") }}\n{{ h.i18n(\"Login & Admin?\", \"登录 & 管理?\", \"zh_cn\") }}\n{{ h.i18n(\"Home\", \"首页\", \"zh_cn\") }}\n{{ h.i18n(\"Source\", \"源码\", \"zh_cn\") }}\n{{ h.i18n(\"Document\", \"文档\", \"zh_cn\") }}\n{{ h.i18n(\"Template API\", \"模板 API\", \"zh_cn\") }}\n\n    <div class=\"bitcron_nav\">\n      <div class=\"mixed_site_nav_wrap site_nav_wrap\">\n        <ul class=\"mixed_site_nav site_nav sm sm-base\">\n          <li>{{ h.a(h.i18n('Home'), href='/') }}</li>\n\n          <li>{{ h.a(h.i18n('Source'), href='https://github.com/hepochen/farbox', target=\"_blank\") }}</li>\n\n          <li>{{ h.a(h.i18n('Template API'), href='https://api.farbox.org', target=\"_blank\") }}</li>\n\n          <li>{{ h.a(h.i18n('Document'), href='https://doc.farbox.org', target=\"_blank\") }}</li>\n\n        </ul>\n\n        <div class=\"clear clear_nav_inline_end\"></div>\n\n      </div>\n\n    </div>\n\n    <div class=\"page_h\">\n      <div class=\"page_h_wrap\">\n        <div class=\"pure-g v_center page_h_body\">\n          <div class=\"pure-u-1 pure-u-md-1 pure-u-lg-2-5\">\n            <div class=\"lr_left left\">\n              <h2 class=\"title\">FarBox 2.0<sup style=\"font-size:16px;top:-1.5em;color:indianred;\"> alpha </sup></h2>\n\n              <div class=\"description\">{{ h.i18n(\"description\") }}</div>\n\n              <div class=\"links\">{{ html.a(h.i18n('Register'), href='/__register', class='primary') }}\n{{ html.a(h.i18n('Login & Admin?'), '/admin') }}\n\n              </div>\n\n            </div>\n\n          </div>\n\n          <div class=\"pure-u-1 pure-u-md-1 pure-u-lg-3-5\">\n            <div class=\"lr_right right\"><img src=\"{{h.url('/fb_static/pages/default_homepage/markdown@2x.jpg')}}\" />\n\n            </div>\n\n          </div>\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "form_dom": "{{ h.load('/fb_static/api/html/form/fields/form.css') }}\n{{ h.i18n(\"+Add\", \"+添加\", \"zh_cn\") }}\n\n{% macro label_maker(field) %}\n{% if  field.tip and field.title %}\n<label for=\"{{field.key}}\"  class=\"with_tip\">{{ _(field.title) }}</label>\n{% if  '://' not in field.tip %}<span aria-label=\"{{_(field.tip)}}\"  class=\"tip hint--bottom\">?</span>\n\n{% else %}<span aria-label=\"{{_(\"click to open the help page\")}}\"  class=\"tip_link hint--bottom\"><a href=\"{{field.tip}}\"  target=\"_blank\">?</a>\n</span>\n\n{% endif %}\n\n{% else %}\n<label for=\"{{field.key}}\" >{{ _(field.title) }}</label>\n\n{% endif %}\n\n{% endmacro %}\n\n{% set placeholder = field.placeholder or '' %}\n\n{% set field_container_class = field_container_class or '' %}\n{% if  field.key in ['_', '-'] %}\n<div style=\"clear:both;width:100%;height: 0\"></div>\n\n{% else %}\n{% set field_container_class = field_container_class+' container_for_'+field.key +' container_for_type_'+field.type %}\n\n{% set field_class = field.field_class or '' %}\n\n{% set field_class = field_class + ' field' %}\n\n<div style=\"{{field.style or ''}}\"  class=\"{{field_container_class}}\" >\n  <div class=\"{{field_class}}\" >{% if  field.type == 'select' and field.options %}{{ label_maker(field) }}\n    <select name=\"{{field.key}}\"  class=\"display_field\">{% for option_value,option_title in field.options %}{% if  option_value == field.value %}\n      <option value=\"{{option_value}}\"  selected=\"selected\">{{ _(option_title) }}</option>\n\n{% else %}\n      <option value=\"{{option_value}}\" >{{ _(option_title) }}</option>\n\n{% endif %}\n\n{% endfor %}\n    </select>\n\n{% elif  field.type == 'text' or file_field == 'textarea' %}{{ label_maker(field) }}\n{% set dom_height = field.height or '' %}\n<textarea name=\"{{field.key}}\"  placeholder=\"{{placeholder}}\"  style=\"{{'height:%s'%dom_height}}\"  class=\"display_field\">{{ field.value }}</textarea>\n\n{% elif  field.type == 'file' %}{{ label_maker(field) }}<span data-filepath=\"{{field.fielpath}}\"  data-post-url=\"{{field.post_url}}\"  name=\"{{field.key}}\"  class=\"display_field form_file_dom\">{{ field.placeholder }}</span>\n\n{% elif  field.type == 'image' %}{% if  field.show_label %}{{ label_maker(field) }}\n{% endif %}\n    <div class=\"image_block display_field\">{% if  not field.value.startswith('/fb_static/') and not d.has(field.value) %}\n{% set image_src = \"/drop_image_here.png\" %}\n\n{% else %}\n{% set image_src = field.value %}\n\n{% endif %}\n\n{% set clear_is_delete = 'yes' if field.clear_is_delete else '' %}\n<img src=\"{{image_src}}\"  data-filepath=\"{{field.value}}\"  data-clear-is-delete=\"{{clear_is_delete}}\"  data-post-url=\"{{field.post_url}}\"  name=\"{{field.key}}\"  class=\"form_image_dom\"/>\n<a href=\"#\" class=\"action_button upload_image_action\">upload</a>\n{% if  not field.hide_clear_action %}<a href=\"#\" onclick=\"clear_image_filepath(this); return false\" class=\"action_button clear_image_filepath_action\">clear</a>\n\n{% endif %}\n      <div style=\"display:none\" class=\"percent_bar\">\n        <div class=\"percent\"></div>\n\n      </div>\n    </div>\n\n{% elif  field.type == 'dom_list' and field.form_keys %}\n{% set dom_list_body_class = \"dom_list_for_%s %s\"%(field.key, field.css_class or '') %}\n{% if  field.only_one %}\n{% set dom_list_body_class = dom_list_body_class+\" dom_list_only_one\" %}\n\n{% endif %}\n    <div data-value=\"{{field.key}}\"  class=\"dom_list display_field\">\n      <div class=\"{{dom_list_body_class}}\" >{% if  field.title %}\n        <h3><span>{{ field.title }}</span>\n{% if  field.tip %}{% if  '://' not in field.tip %}<span aria-label=\"{{_(field.tip)}}\"  class=\"tip hint--bottom\">?</span>\n\n{% else %}<span aria-label=\"{{_(\"click to open the help page\")}}\"  class=\"tip_link hint--bottom\"><a href=\"{{field.tip}}\"  target=\"_blank\">?</a>\n</span>\n\n{% endif %}\n\n{% endif %}\n        </h3>\n\n{% endif %}{% if  not field.only_one %}\n        <div class=\"dom_list_actions\"><a href=\"#\" onclick=\"javascript:add_dom_list_item(this); return false;\" class=\"dom_list_add_action action_button add\">{{ _(\"+Add\") }}</a>\n\n        </div>\n\n{% endif %}\n{% set list_value = field.value or [] %}\n{% if  not list_value.is_array %}\n{% set list_value = [] %}\n\n{% endif %}{% if  not list_value and field.only_one and 'image' in field.key %}\n{% set list_value = [{'src': '/drop_image_here.png', 'alt': '', 'class':'', 'title':''}] %}\n\n{% endif %}{{ list_value.append({\"dom_class\": \"template\", \"dom_style\": \"display:none\"}) }}\n\n        <div class=\"dom_list_body\">{% for sub_value in list_value %}\n{% set dom_class = 'dom_list_item ' + (sub_value.dom_class or '') %}\n\n          <div style=\"{{sub_value.dom_style or ''}}\"  class=\"{{dom_class}}\" >{% for form_key in field.form_keys %}\n            <div class=\"dom_list_item_element\">{{ h.create_form_dom(sub_value, form_key=form_key) }}\n\n            </div>\n\n{% endfor %}{% if  not field.only_one %}<a href=\"#\" onclick=\"javascript:remove_dom_list_item(this);return false;\" class=\"dom_list_delete_action action_button delete\">x</a>\n\n{% endif %}\n          </div>\n\n{% endfor %}\n        </div>\n\n      </div>\n\n    </div>\n\n{% elif  field.type == 'span' %}{{ label_maker(field) }}<span style=\"{{field.style or ''}}\"  class=\"display_field span_field\">{{ field.value }}</span>\n\n{% elif  field.type == 'caption' %}\n    <div class=\"caption\">{{ label_maker(field) }}\n    </div>\n\n{% elif  field.type == 'password' %}{{ label_maker(field) }}\n    <input type=\"password\" value=\"{{field.value}}\"  name=\"{{field.key}}\"  class=\"display_field\"/>\n\n{% elif  field.type == \"hidden\" %}\n    <input type=\"hidden\" value=\"{{field.value}}\"  name=\"{{field.key}}\" />\n\n{% elif  field.type == 'color' %}{{ label_maker(field) }}\n    <input value=\"{{field.value}}\"  name=\"{{field.key}}\"  placeholder=\"{{placeholder}}\"  class=\"display_field color_input\"/>\n\n{% elif  field.type == 'icon' %}{% if  field.value %}<span class=\"icon\"><i class=\"{{field.value}}\" ></i>\n</span>\n\n{% else %}<span class=\"icon\"><i>?</i>\n</span>\n{% endif %}\n\n    <input value=\"{{field.value}}\"  name=\"{{field.key}}\"  type=\"hidden\" class=\"display_field icon_input\"/>\n<a href=\"javascript:void(0)\" onclick=\"pick_icon_for_field(this)\">select</a>\n\n{% elif  field.type == \"date\" %}{{ label_maker(field) }}\n{% set input_class = 'display_field %s' % field.key %}\n\n    <input type=\"date\" value=\"{{field.value}}\"  placeholder=\"{{placeholder}}\"  name=\"{{field.key}}\"  class=\"{{input_class}}\" />\n\n{% else %}{{ label_maker(field) }}\n{% set input_class = 'display_field %s' % field.key %}\n\n    <input type=\"text\" value=\"{{field.value}}\"  placeholder=\"{{placeholder}}\"  name=\"{{field.key}}\"  class=\"{{input_class}}\" />\n\n{% endif %}\n\n  </div>\n</div>\n\n{% endif %}\n{{ h.load(\"jquery\") }}\n{{ h.load(\"/fb_static/lib/jquery.json.min.js\") }}\n{{ h.load('/fb_static/lib/hint.min.css') }}\n{% if  field.type == 'dom_list' %}{{ h.load(\"/fb_static/lib/jquery-ui.min.js\") }}\n\n{% endif %}{% if  field.type in ['color', 'dom_list'] %}{{ h.load('/fb_static/lib/minicolors/jquery.minicolors.css') }}\n{{ h.load('/fb_static/lib/minicolors/jquery.minicolors.min.js') }}\n{{ h.load(\"/fb_static/api/html/form/fields/color.js\") }}\n\n{% endif %}{{ h.load(\"/fb_static/api/html/form/file_field.js\") }}\n{{ h.load(\"/fb_static/api/html/form/fields/form.js\") }}\n{% if  field.type in ['image', 'dom_list'] %}{{ h.load(\"/fb_static/api/html/form/fields/image.js\") }}\n{{ h.load('/fb_static/lib/webuploader.html5only.min.js') }}\n\n{% endif %}{% if  field.type in ['icon', 'dom_list'] %}{{ h.load('font') }}\n{{ h.load('/fb_static/lib/fontawesome/selector/icon-selector.css') }}\n{{ h.load('/fb_static/lib/fontawesome/selector/icon-selector.js') }}\n{{ h.load(\"/fb_static/api/html/form/fields/icon.js\") }}\n\n{% endif %}{{ h.load('alert') }}", 
    "js_view": "{{ h.load(\"/fb_static/api/html/js_view/colorbox.css\") }}\n{{ h.load(\"jquery\") }}\n{{ h.load(\"/fb_static/api/html/js_view/jquery.colorbox.js\") }}\n{{ h.load(\"/fb_static/api/html/js_view/js_view.js\") }}\n{% if  view_type == 'image' and thumbnail %}<a href=\"{{url}}\"  title=\"{{title}}\"  data-group-id=\"{{group_id}}\"  id=\"{{dom_id}}\"  style=\"{{style}}\"  onclick=\"show_js_view(this);return false;\" class=\"{{css_class}}\" ><img src=\"{{thumbnail}}\" />\n</a>\n\n{% elif  view_type == 'video' %}{{ h.load('/__video-js.min.css') }}\n{{ h.load('/__video.min.js') }}\n<a href=\"{{'#%s'%uuid}}\"  id=\"{{dom_id}}\"  data-width=\"{{width}}\"  data-height=\"{{height}}\"  data-group-id=\"{{group_id}}\"  onclick=\"show_js_view(this);return false;\" class=\"{{css_class}}\" >{{ title }}\n  <div style=\"display:none\" class=\"video_container\">\n    <div id=\"{{uuid}}\"  class=\"video_player\">\n      <video controls=\"controls\" preload=\"none\" data-setup=\"{}\" id=\"{{'player_%s'%uuid}}\"  class=\"video-js vjs-default-skin\">\n        <source src=\"{{url}}\"  type=\"video/mp4\"></source>\n\n      </video>\n\n    </div>\n\n  </div>\n</a>\n\n{% elif  view_type in [\"qrcode\", \"erweima\"] %}{{ h.load(\"/fb_static/api/html/js_view/jquery.qrcode.min.js\") }}\n<a href=\"{{url}}\"  id=\"{{dom_id}}\"  onclick=\"show_js_view(this);return false;\" class=\"js_view js_view_html\">{{ title }}\n  <div style=\"display:none\" class=\"js_view_inner_html\">\n    <div id=\"{{uuid}}\"  class=\"qrcode_dom\"></div>\n\n  </div>\n</a>\n\n{% set qrcode_width = qrcode_width or 250 %}\n\n{% set qrcode_height = qrcode_height or 250 %}\n\n<script>var url = \"{{ url}}\";\nif (url.indexOf(\"/\")==0){ url = location.protocol + '//' + location.host + url}\nvar qrcode = new QRCode(document.getElementById(\"{{ uuid }}\"), {\n        text: url,\n        width: {{qrcode_width}},\n        height: {{qrcode_height}},\n        colorDark : \"#000000\",\n        colorLight : \"#ffffff\",\n        correctLevel : QRCode.CorrectLevel.H\n});\n\n</script>\n{% elif  view_type == 'modal' %}{{ h.load('/fb_static/api/html/js_view/jquery.modal.css') }}\n{{ h.load('/fb_static/api/html/js_view/jquery.modal.js') }}\n<a href=\"#\" id=\"{{dom_id}}\"  style=\"{{style}}\"  class=\"{{css_class}}\" >{{ title }}</a>\n\n<script>$(document).ready(function(){\n    $(\"{{url}}\").click(function(){$(\"{{ target }}\").modal();return false;})\n});\n\n</script>\n{% elif  view_type == 'image' and group_id %}<a href=\"{{url}}\"  data-group-id=\"{{group_id}}\"  style=\"{{style}}\"  class=\"{{css_class}}\" >{{ title }}</a>\n\n{% else %}<a href=\"{{url}}\"  style=\"{{style}}\"  onclick=\"show_js_view(this);return false;\" class=\"{{css_class}}\" >{{ title }}</a>\n\n{% endif %}", 
    "page_file_csv_editor": "<!DOCTYPE html>\n<html>\n{% set doc_path = request.get_offset_path(1) %}\n\n{% set doc = d.get_doc(doc_path) %}\n\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n\n    <title>{{ doc.path }}</title>\n{{ h.load('/fb_static/pages/csv_editor/csv.css') }}\n\n  </head>\n\n  <body>{{ h.i18n(\"New Row\", \"新行\", \"zh_cn\") }}\n{{ h.i18n(\"Remove Row\", \"删除行\", \"zh_cn\") }}\n{{ h.i18n(\"New Column\", \"新栏\", \"zh_cn\") }}\n{{ h.i18n(\"Remove Column\", \"删除栏\", \"zh_cn\") }}\n{{ h.i18n(\"Save\", \"保存\", \"zh_cn\") }}\n\n    <div class=\"buttons\"><a id=\"add_row\" href=\"javascript:void(0)\" onclick=\"add_new_row()\">{{ h.i18n(\"New Row\") }}</a>\n<a id=\"remove_row\" href=\"javascript:void(0)\" onclick=\"remove_row()\">{{ h.i18n(\"Remove Row\") }}</a>\n<a id=\"add_column\" href=\"javascript:void(0)\" onclick=\"add_new_column()\">{{ h.i18n(\"New Column\") }}</a>\n<a id=\"remove_column\" href=\"javascript:void(0)\" onclick=\"delete_column()\">{{ h.i18n(\"Remove Column\") }}</a>\n<a id=\"save_button\" href=\"javascript:void(0)\" onclick=\"save()\">{{ h.i18n(\"Save\") }}</a>\n<span id=\"info\"></span>\n\n    </div>\n\n    <table>\n      <!-- 补全-->\n\n{% set data = doc.data %}\n{% if  not data %}\n{% set data = [['', ''], ['', '']] %}\n\n{% elif  data.length == 1 %}\n{% set row_length = data[0].length %}\n\n{% set data = [data[0], ['']*row_length] %}\n\n{% endif %}\n{% if  data.length>1 %}\n      <thead>\n        <tr>{% for value in data[0] %}\n          <th contenteditable=\"true\">{{ value }}</th>\n\n{% endfor %}\n        </tr>\n      </thead>\n\n      <tbody>{% for row in data[1:] %}\n        <tr>{% for value in row %}{% if  value %}\n{% set value = value.escaped %}\n\n{% endif %}\n          <td contenteditable=\"true\">{{ (value or '&nbsp;').replace('\\n', '<br />') }}</td>\n\n{% endfor %}\n        </tr>\n{% endfor %}\n      </tbody>\n{% elif  data %}\n      <!-- no header-->\n\n      <tbody>\n        <tr>{% for value in data[0] %}\n          <td contenteditable=\"true\">{{ value or '&nbsp;' }}</td>\n\n{% endfor %}\n        </tr>\n      </tbody>\n\n{% endif %}\n\n    </table>\n\n    <input id=\"doc_path\" type=\"hidden\" value=\"{{doc_path}}\" />\n{{ h.load('jquery') }}\n{{ h.load('/fb_static/pages/csv_editor/csv.js') }}\n\n  </body>\n\n</html>", 
    "page_admin_bucket_expired_date": "<html>\n  <header>\n    <title>Bucket Expired Date</title>\n{{ h.load('/fb_static/pages/page.css') }}\n\n    <style type=\"text/css\">.simple_form .buttons button { margin:0 10px !important;}\n</style>\n  </header>\n\n  <body>{{ h.i18n('Submit', '提交', 'zh_cn') }}\n{{ h.i18n('Invitation Code', '邀请码', 'zh_cn') }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>Bucket Expired Date</h1>\n\n        </div>\n\n        <div class=\"content_container\">{% if  service_info.expired_date %}\n          <p style=\"text-align:center;\">expired date of <b>{{service_info.bucket}}</b> is <b>{{service_info.expired_date(\"%Y-%m-%d\")}}</b></p>\n\n{% endif %}{{ h.simple_form(\"\", ['bucket(type=input, title=\"Bucket\")', 'date(type=date, title=\"Expired Date\")', 'days(title=\"or +Days\")'], submit_text=h.i18n(\"Submit\"), info=info) }}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "back_to_top": "<style type=\"text/css\">a.back_to_top {\n    text-decoration: none;\n    position: fixed;\n    bottom: 40px;\n    right: 30px;\n    background: #f0f0f0;\n    height: 40px;\n    width: 40px;\n    border-radius: 50%;\n    line-height: 36px;\n    font-size: 18px;\n    text-align: center;\n    transition-duration: .5s;\n    transition-propety: background-color;\n    display: none;\n}\n\na.back_to_top span {\n    color: #888;\n}\n\na.back_to_top:hover {\n    cursor: pointer;\n    background: #dfdfdf;\n}\n\na.back_to_top:hover span {\n    color: #555;\n}\n\n@media print, screen and (max-width: 580px) {\n    .back_to_top {\n        display: none !important;\n    }\n}\n\n\n\n</style><a id=\"back_to_top\" href=\"#\" class=\"back_to_top\"><span>{{ label or '△' }}</span>\n</a>\n{{ h.load(\"jquery\") }}\n\n<script>$(document).ready((function(_this) {\n  return function() {\n    var bt;\n    bt = $('#back_to_top');\n    if ($(document).width() > 480) {\n      $(window).scroll(function() {\n        var st;\n        st = $(window).scrollTop();\n        if (st > 30) {\n          return bt.css('display', 'block');\n        } else {\n          return bt.css('display', 'none');\n        }\n      });\n      return bt.click(function() {\n        $('body,html').animate({\n          scrollTop: 0\n        }, 800);\n        return false;\n      });\n    }\n  };\n})(this));\n</script>", 
    "builtin_theme_knowbase_tag": "{% extends \"builtin_theme_knowbase_base.jade\" %}\n\n{% block title %}\n\n<title>{{ \"#%s\"%current_tag }}</title>\n\n{% endblock %}\n\n{% block content %}\n\n{% set is_from_wiki_notes = request.values.source == \"wiki_nodes\" %}\n\n{% set href_target = \"_blank\" if is_from_wiki_notes else \"\" %}\n\n<div class=\"common_page_wrap\">\n  <div class=\"common_page\">\n    <div class=\"common_page_core\">\n      <div class=\"page_header\"><a href=\"/wiki\" target=\"{{href_target}}\"  class=\"homepage\">Home</a>\n<span class=\"split\">></span>\n<span>{{ \"#%s\"%current_tag }}</span>\n\n      </div>\n\n      <div class=\"page_body\">{% for doc in docs %}\n        <div class=\"item\"><a href=\"{{\"%s#main\"%doc.wiki_url}}\"  target=\"{{href_target}}\" >\n            <h2>{{ doc.title }}</h2>\n</a>\n          <div class=\"summary\">{{ doc.metadata.summary or doc.content.plain.limit(120).plain }}</div>\n\n        </div>\n\n{% endfor %}\n      </div>\n{{ h.paginator(style='auto') }}\n\n      <!--if is_from_wiki_notes-->\n\n      <!--    +h.load(\"jquery\")-->\n\n      <!--    +h.load('/fb_static/lib/jquery.modal.js')-->\n    </div>\n\n  </div>\n\n</div>\n\n{% endblock %}", 
    "page_user_markdown_page": "<!DOCTYPE html>\n<html>\n{% set doc_path = request.get_offset_path(1) %}\n\n{% set doc = md_doc or d.get_doc(\"_page/\"+doc_path+\".md\") %}\n{% if  not doc %}{{ response.raise_404(doc_path) }}\n\n{% endif %}\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n\n    <title>{{ doc.title }}</title>\n{{ h.mobile_metas }}\n{{ h.load('/fb_static/pages/markdown_page.css') }}\n{% if  site.page_text_indent %}\n    <style type=\"text/css\">p.md_block{ }\nspan.md_line{text-indent: 28px; display:block; margin-bottom:0.5em; line-height:2.2; }\nli .md_line{\n    text-indent: 0; display: inline; padding: 0;\n}\n.md_line br{ display: none;}\nblockquote{ margin-left: 0.5em; }\nblockquote span.md_line{ text-indent: 0;}\nspan.md_line.md_line_dom_embed.md_line_with_image{text-indent:0}\nsup {text-indent: 0;}\n</style>\n{% endif %}\n  </head>\n\n  <body>\n    <div class=\"post\">{% if  show_site_nav %}\n      <div class=\"nav\">{{ site.nav }}</div>\n\n{% elif  doc.metadata.show_site_nav in [True, \"true\", \"yes\"] %}\n      <div class=\"nav\">{{ site.nav }}</div>\n\n{% elif  doc.metadata.nav and doc.metadata.nav.is_array %}\n      <div class=\"nav\">{{ site.get_nav(meta_doc=doc) }}</div>\n\n{% endif %}\n\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>{{ doc.title }}</h1>\n\n        </div>\n\n        <div class=\"content_container\">{{ doc.content }}</div>\n\n      </div>\n\n    </div>\n\n  </body>\n</html>", 
    "page_user_template": "<html>\n  <header>{{ h.mobile_metas }}\n\n    <title>Theme for FarBox</title>\n{{ h.load('/fb_static/pages/page.css') }}\n\n    <style type=\"text/css\">.simple_form .buttons button { margin:0 10px !important;}\n</style>\n  </header>\n\n  <body>{{ h.i18n(\"url_note\", \"(anyone get the URL can copy your theme and URL will expire after 24 hours)\") }}\n{{ h.i18n(\"url_note\", \"(任何人获得这个 URL 都可以拷贝你的主题，另外 URL 将会在 24 小时后失效)\") }}\n{{ h.i18n(\"note\", \"`Source` can be a folder under your bucket or the Theme URL of other's bucket; \") }}\n{{ h.i18n(\"note\", \"`源`可以是你自己 bucket 下的一个目录，也可以是别人 bucket 对应的 Theme URL； \") }}\n{{ h.i18n(\"Source\", \"源\", \"zh_cn\") }}\n{{ h.i18n(\"Source:\", \"源：\", \"zh_cn\") }}\n{{ h.i18n('Submit', '提交', 'zh_cn') }}\n{{ h.i18n(\"only supports\", \"仅支持\", \"zh_cn\") }}\n{{ h.i18n(\"max_size\", \"and the size of all files of a theme should be less than 500Kb.\") }}\n{{ h.i18n(\"max_size\", \"并且一个 Theme 下所有文件的总大小应该小于 500Kb。\") }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>Theme</h1>\n\n        </div>\n\n        <div class=\"content_container\">\n          <p><span>Current Bucket Theme URL:</span>\n<br/>\n<span style=\"color:indianred\">{{ b.theme_api_url }}</span><br/>\n<span>{{ h.i18n(\"url_note\") }}</span>\n          </p>\n\n          <p><span>{{ h.i18n(\"note\") }}</span>\n<span>{{ h.i18n(\"only supports\") + \" (jade scss css less json js html htm); \" }}</span>\n<span>{{ h.i18n(\"max_size\") }}</span>\n\n          </p>\n{% if  request.method == \"POST\" and request.values.source %}\n{% set info = b.apply_theme(request.values.source) %}\n\n{% endif %}\n{% set data_obj = {\"source\": request.values.source or \"/template\"} %}\n{{ h.simple_form(\"\", ['source(type=input, title=\"Source:\")'], submit_text=h.i18n(\"Submit\"), info=info, data_obj=data_obj) }}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "page_user_create_bucket": "<html>\n  <header>\n    <title>Create Bucket</title>\n{{ h.mobile_metas }}\n{{ h.load('/fb_static/pages/page.css') }}\n\n  </header>\n\n  <body>{{ h.i18n(\"Create New Bucket\", \"创建新的 Bucket\", \"zh_cn\") }}\n{{ h.i18n(\"Create Bucket\", \"创建 Bucket\", \"zh_cn\") }}\n{{ h.i18n(\"Private Key\", \"私钥\", \"zh_cn\") }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>{{ h.i18n(\"Create New Bucket\") }}</h1>\n\n        </div>\n\n        <div class=\"content_container\">{% if  \"cn\" in request.lang %}\n          <p><b>在创建 Bucket 之前，请确保你已经理解:</b>\n\n          </p>\n          <p><span>1， 务必务必将 <b>私钥</b> 保存到某个地方，如果你遗失了它，就会失去对数据的控制，并且没有人可以帮到你。</span>\n\n          </p>\n          <p><span>2， 你可以使用默认自动填充的 <b>私钥</b>，也可以替换为自己的、旧的 <b>私钥</b>.</span>\n\n          </p>\n          <p><span>3， 再次重复，<b>先保存私钥后，再点击\"创建 Bucket\"</b>！！</span>\n\n          </p>\n{% else %}\n          <p><b>Before Create Bucket, Make Sure You Understand:</b>\n\n          </p>\n          <p><span>1, Store the <b>Private Key</b> somewhere by yourself, if you lost it, you will lost the control of your data, and no one can help.</span>\n\n          </p>\n          <p><span>2, You can use <b>Private Key</b> auto-filled by default, or replace with your own <b>Private Key</b>.</span>\n\n          </p>\n          <p><span>3, Repeat again, <b>STORE PRIVATE KEY FIRST BEFORE CLICK \"CRETE BUCKET\"</b>!!</span>\n\n          </p>\n{% endif %}\n{% if  register_note %}\n          <p>{{ register_note }}</p>\n\n{% endif %}\n{% set data_obj = {\"private_key\": private_key} %}\n{{ h.simple_form(\"\", ['private_key(type=text, height=300, title=\"Private Key\")'], data_obj=data_obj, info=info, submit_text=\"Create Bucket\") }}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "builtin_theme_knowbase_base": "<!DOCTYPE html>\n<html>\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n{{ h.headers }}\n\n{% block title %}\n\n    <title>{{ wiki_title or site.title }}</title>\n\n{% endblock %}\n{% if  wiki_configs.main_color %}{{ h.load(\"/fb_static/builtin_themes/knowbase/style.scss\", scss=True, header_color=wiki_configs.header_color,             main_color=wiki_configs.main_color, secondary_color=wiki_configs.secondary_color) }}\n\n{% else %}{{ h.load(\"/fb_static/builtin_themes/knowbase/style.css\") }}\n\n{% endif %}\n\n  </head>\n\n  <body>{% if  request.values.source != \"wiki_nodes\" %}{{ site.nav }}\n\n{% endif %}{% if  request.values.source != \"wiki_nodes\" %}\n{% set cover_url = site.get_image_url(\"bg.jpg\", '/fb_static/unsplash/2.jpg') %}\n\n    <div id=\"particles-js\" style=\"{{\"background-image:url(%s)\"%cover_url}}\"  class=\"header\">{{ posts.search_in_html(show_button=True, base_url='/wiki/search', placeholder=wiki_configs.search_placeholder) }}\n\n    </div>\n\n{% endif %}\n    <div id=\"main\" class=\"main\">\n{% block content %}\n\n{% endblock %}\n\n    </div>\n\n    <div class=\"footer\"><a target=\"_blank\" href=\"{{request.url_root}}\"><span>All content copyright {{site.title}} © {{site.now.year}} • All rights reserved.</span>\n</a>\n      <div class=\"powered_by\"><a href=\"https://www.farbox.com\" target=\"_blank\">Proudly published with FarBox&#65281</a>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "builtin_theme_knowbase_category": "{% extends \"builtin_theme_knowbase_base.jade\" %}\n\n{% block title %}\n{% if  not category %}{{ response.raise_404() }}\n\n{% endif %}\n<title>{{ category.title }}</title>\n\n{% endblock %}\n\n\n{% block content %}\n{{ h.i18n(\"Sub-Categories:\", \"子目录:\") }}\n{{ h.i18n(\"Tags:\", \"标签:\") }}\n\n<div class=\"common_page_wrap\">\n  <div class=\"common_page\">\n    <div class=\"common_page_core\">\n      <div class=\"page_header\"><a href=\"/wiki\" class=\"homepage\">Home</a>\n{% for parent_category in category.get_parents(wiki_root) %}<span class=\"split\">></span>\n<a href=\"{{\"%s#main\"%parent_category.get_url(\"/wiki/category\", root=wiki_root)}}\"  class=\"parent_category\">{{ parent_category.title }}</a>\n\n{% endfor %}<span class=\"split\">></span>\n<a href=\"{{\"%s#main\"%category.get_url(\"/wiki/category\", root=wiki_root)}}\"  class=\"category\">{{ category.title }}</a>\n{% if  wiki_nodes_url %}<a href=\"{{wiki_nodes_url}}\"  target=\"_blank\" class=\"href\"><small style=\"margin-left:5px;font-weight:normal;font-size:70%;\">(Wiki Nodes)</small>\n</a>\n\n{% endif %}{% if  category.children %}\n        <div class=\"sub_categories\"><span>{{ h.i18n(\"Sub-Categories:\") }}</span>\n{% for sub_category in category.children %}<a href=\"{{\"%s#main\"%sub_category.get_url(\"/wiki/category\", root=wiki_root)}}\" ><span class=\"title\">{{ sub_category.title }}</span>\n<span class=\"count\">{{ '(%s)' % sub_category.posts_count }}</span>\n</a>\n\n{% endfor %}\n        </div>\n\n{% endif %}{% if  category.tags %}\n        <div class=\"sub_categories\"><span>{{ h.i18n(\"Tags:\") }}</span>\n{% for tag,tag_count in category.tags %}<a href=\"{{\"/wiki/tag/%s\"%tag}}\" ><span class=\"title\">{{ tag }}</span>\n<span class=\"count\">{{ \"(%s)\" % tag_count }}</span>\n</a>\n\n{% endfor %}\n        </div>\n\n{% endif %}\n      </div>\n\n      <div class=\"page_body\">{% for doc in docs %}\n        <div class=\"item\"><a href=\"{{\"%s#main\"%doc.wiki_url}}\" >\n            <h2>{{ doc.title }}</h2>\n</a>\n          <div class=\"summary\">{{ doc.metadata.summary or doc.content.plain.limit(120).plain }}</div>\n\n        </div>\n\n{% endfor %}\n      </div>\n{{ h.paginator(style='auto') }}\n\n    </div>\n\n  </div>\n\n</div>\n\n{% endblock %}", 
    "api_namespace_html_nav": "{% if  load_front_sources %}{{ h.load(\"jquery\") }}\n{{ h.load(\"/__jquery.smartmenus.js\") }}\n{{ h.load(\"/__sm-core-css.css\") }}\n{{ h.load(\"/__sm-base.css\") }}\n{{ h.load(\"/__run_menu.js\") }}\n{{ h.load(\"/__nav.css\") }}\n\n{% endif %}\n<div class=\"farbox_nav_container bitcron_nav_container\">{% if  toggle_menu %}\n  <div class=\"menu_toggle\">\n{% set menu_state_dom_id = h.random_dom_id + '_nav' %}\n\n    <input type=\"checkbox\" id=\"{{menu_state_dom_id}}\"  class=\"menu_state\"/>\n\n    <label for=\"{{menu_state_dom_id}}\"  class=\"menu_btn\"><span class=\"menu_btn_icon\">Toggle main menu visibility</span>\n\n    </label>\n\n    <style type=\"text/css\">@media (max-width: 767px){\n    .farbox_nav { display: none; }\n}\n\n\n</style>\n  </div>\n\n{% endif %}{% if  nav_type == \"plain\" %}{% if  nav_data %}\n  <div class=\"farbox_nav bitcron_nav\">\n    <div class=\"site_nav_wrap\">\n      <ul class=\"site_nav sm sm-base\">{% for nav_name,nav_link in nav_data %}\n        <li>{{ h.auto_a(nav_name, nav_link, class='nav__item') }}</li>\n\n{% endfor %}\n      </ul>\n\n      <div class=\"clear clear_nav_inline_end\"></div>\n\n    </div>\n\n  </div>\n\n{% endif %}\n{% else %}\n{% macro create_nav_item_html(nav_item) %}\n{% if  nav_item.name %}\n  <li>{{ h.auto_a(h.i18n(nav_item.name), nav_item.url or '#', class='nav__item') }}\n{% if  nav_item.children %}\n    <ul>{% for sub_nav_item in nav_item.children %}{{ create_nav_item_html(sub_nav_item) }}\n{% endfor %}\n    </ul>\n{% endif %}\n  </li>\n\n{% endif %}\n{% endmacro %}\n\n  <div class=\"farbox_nav bitcron_nav\">\n    <div class=\"mixed_site_nav_wrap site_nav_wrap\">\n      <ul class=\"mixed_site_nav site_nav sm sm-base\">{% for nav_item in nav_data %}{{ create_nav_item_html(nav_item) }}\n{% endfor %}\n      </ul>\n\n      <div class=\"clear clear_nav_inline_end\"></div>\n\n    </div>\n\n  </div>\n\n{% endif %}\n\n  <div class=\"clear clear_nav_end\"></div>\n\n</div>", 
    "page_user_extend_bucket": "<html>{{ h.i18n(\"Extends Bucket Period\", \"延长 Bucket 有效期\", \"zh_cn\") }}\n{{ h.i18n(\"Click Here to Extends Bucket Period One More Year (by AliPay)\", \"点击此处，延长 Bucket 一年有效期 (支付宝)\", \"zh_cn\") }}\n{{ h.i18n(\"Bucket Expired Date:\", \"Bucket 有效期至：\", \"zh_cn\") }}\n\n  <header>{{ h.mobile_metas }}\n\n    <title>{{ i18n(\"Extends Bucket Period\") }}</title>\n{{ h.load('/fb_static/pages/page.css') }}\n\n  </header>\n\n  <body>\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>{{ i18n(\"Extends Bucket Period\") }}</h1>\n\n        </div>\n\n        <div class=\"content_container\">{% if  \"cn\" in request.lang %}\n          <p style=\"color:red\">注意： 跳转到支付宝支付成功后，不要关闭窗口，等待页面自动跳转回来！</p>\n\n{% endif %}{% if  b.logined_bucket %}\n          <p><span>{{ h.i18n(\"Bucket Expired Date:\") }}</span>\n{% if  b.service_info.expired_date %}<span>{{ b.service_info.expired_date(\"%Y-%m-%d\") }}</span>\n\n{% else %}<span>?</span>\n\n{% endif %}\n\n          </p>\n\n          <p><a href=\"?action=do\">{{ i18n(\"Click Here to Extends Bucket Period One More Year (by AliPay)\")+\" ￥%s/year\"%price }}</a>\n\n          </p>{% if  price2 %}\n          <p><a href=\"?action=do&try_price2=true\">{{ i18n(\"Click Here to Extends Bucket Period One More Year (by AliPay)\")+\" ￥%s/year\"%price2 }}</a>\n\n          </p>\n{% endif %}{% if  price_note %}\n          <p>{{ price_note }}</p>\n\n{% endif %}{% if  order_ids %}\n          <p><span style=\"margin-right:10px\">Old Order IDs:</span>\n<br/>\n{% for order_id in order_ids %}<span style=\"margin-right:10px\">{{ order_id }}</span>\n\n{% endfor %}\n          </p>\n\n{% endif %}\n{% else %}\n          <p>no bucket is login already</p>\n\n{% endif %}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n</html>", 
    "builtin_theme_wiki_nodes": "<!DOCTYPE html>\n<html>\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n{{ h.load(\"/fb_static/lib/three/three.js\") }}\n{{ h.load(\"/fb_static/lib/three/three-spritetext.min.js\") }}\n{{ h.load(\"/fb_static/lib/three/3d-force-graph.min.js\") }}\n{{ h.load(\"jquery\") }}\n{{ h.load('/fb_static/lib/jquery.modal.css') }}\n{{ h.load('/fb_static/lib/jquery.modal.js') }}\n\n    <title>{{ request.values.path or wiki_title or site.title }}</title>\n\n    <style>body {margin: 0}\n.common_page_wrap .common_page .page_body {\n    padding: 50px 30px 30px 30px !important;\n}\n.common_page_wrap .common_page {\n    padding: 0 !important;\n}\n.modal {\n    width: 70% !important;\n}\n\n.farbox_nav_container {\n    position: fixed;\n    top: 0;\n    height: 50px;\n    width: 100%;\n    z-index: 999;\n}\n.site_nav a{\n    color: white !important;\n}\n.site_nav a.current {\n    color:white !important;\n}\n</style>\n  </head>\n\n  <body>{{ site.nav }}\n\n    <div id=\"3d-graph\"></div>\n<a id=\"page_link\" href=\"#\" style=\"display:none\">Open Page</a>\n\n    <script>const Graph = ForceGraph3D()\n(document.getElementById('3d-graph'))\n    .jsonUrl('?type=data&&path={{request.values.path or \"\"}}')\n    .nodeLabel(\"notid\")\n    .nodeAutoColorBy('group')\n    .onNodeClick(node => {\n        if (node.url) {\n            $(\"#page_link\").attr(\"href\", node.url+\"?source=wiki_nodes\")\n            $(\"#page_link\").modal()\n        }\n    })\n    .nodeThreeObject(node => {\n    const sprite = new SpriteText(node.name);\n    sprite.material.depthWrite = false; // make sprite background transparent\n    sprite.color = node.color;\n    sprite.textHeight = 8;\n    return sprite;\n    });\n// Spread nodes a little wider\nGraph.d3Force('charge').strength(-250);\n</script>\n  </body>\n\n</html>", 
    "page_user_site_settings": "<html>\n  <header>{{ h.mobile_metas }}\n\n    <title>Site Settings</title>\n{{ h.load('/fb_static/pages/page.css') }}\n\n    <style type=\"text/css\">.simple_form .buttons button { margin:0 10px !important;}\n</style>\n  </header>\n\n  <body>{{ h.i18n('Setup', '设置', 'zh_cn') }}\n{{ h.i18n('Anti Hotlinking', '防盗链', 'zh_cn') }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>Site Settings</h1>\n\n        </div>\n\n        <div class=\"content_container\">{% if  \"cn\" in request.lang %}\n          <p>注意：设定项的数据会存储于 settings.json 路径下，在网站是否生效主要取决于模板。</p>\n\n{% else %}\n          <p>Note: The data for settings items is stored under the settings.json path, and whether it takes effect depends on the template.</p>\n\n{% endif %}\n{{ h.simple_form(\"\", ['title', 'sub_title', 'utc_offset(default=8)',                 'image_max_type(type=select, placeholder=\"webp-jpg@,jpg@,png@\", title=\"Thunbmail\")', 'image_max_width(default=1560)', 'image_max_height',                 'post_per_page(default=3)', 'hide_post_prefix(type=bool,title=Hide Post Prefix URL)', 'hide_private_file(type=bool,default=false,title=Hide /_private URL)', 'posts_root', 'albums_root', 'albums_title',                  \"albums_home_sort(type='select', placeholder='by date and desc@-date,by date and asc@date')\",                 \"album_items_sort(type='select', placeholder='by date and desc@-date,by date and asc@date')\",                 'anti_theft_chain(type=bool, default=true, title=\"Anti Hotlinking\")', 'text_indent@bool(default=false)',                 'page_text_indent@bool(default=false)', 'post_content_type(type=select, placeholder=\"markdown@,plaintext@\")',                 'show_post_toc(type=bool, default=false, title=Show TOC)', 'comments@bool(default=true)',                  'comments_type(type=select, placeholder=\"tree@,line@\")', 'mathjax@bool', 'echarts@bool','mermaid@bool',                 'third_party_comments_script(title=\"3rd Comments Script\", type=text, height=100, placeholder=\"like Disqus\")', 'inject_template(type=text, height=150)',                 'cloud_site_folder',                 ],                  submit_text=h.i18n(\"Setup\"), info=info, data_obj=data_obj) }}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "page_file_site_nav": "<html>\n  <header>\n    <title>Site Navigation</title>\n{{ h.load(\"jquery\") }}\n{{ h.load(\"/fb_static/lib/jquery.json.min.js\") }}\n{{ h.load(\"/fb_static/lib/menu/jquery-ui.custom.min.js\") }}\n{{ h.load(\"/fb_static/lib/menu/jquery.mjs.nestedSortable.js\") }}\n{{ h.load(\"/fb_static/pages/site/menu/menu_editor.css\") }}\n{{ h.load(\"/fb_static/pages/site/menu/editor.js\") }}\n\n  </header>\n\n  <body>{% if  request.method == 'POST' %}\n{% set config_path = 'nav.json' %}\n\n{% set nav_configs = request.form.raw_content or '' %}\n\n{% set user_nav_disabled = request.form.get('user_nav_disabled')=='true' %}\n{{ d.update_json(config_path, nav_configs=nav_configs.from_json, user_nav_disabled=user_nav_disabled) }}\n{{ response.response('ok') }}\n\n{% endif %}{{ h.i18n('+ New Item', '+ 新条目', 'zh_cn') }}\n{{ h.i18n('Save', '保存', 'zh_cn') }}\n{{ h.i18n('Disable Custom Navigation', '禁用自定义导航', 'zh_cn') }}\n{{ h.i18n('delete', '删除', 'zh_cn') }}\n\n{% macro create_nav_li(config={}) %}\n\n    <li>\n      <div class=\"item\"><span class=\"move_sign\"><i class=\"move_sign1 fa fa-i fa-ellipsis-v\"></i>\n<i class=\"move_sign2 fa fa-i fa-ellipsis-v\"></i>\n</span>\n\n        <input type=\"text\" name=\"name\" placeholder=\"Name\" value=\"{{config.name or ''}}\" />\n\n        <input type=\"text\" name=\"url\" placeholder=\"URL\" value=\"{{config.url or ''}}\"  oninput=\"show_or_hide_edit_button(this)\" onchange=\"show_or_hide_edit_button(this)\"/>\n<span class=\"actions\"><a href=\"#\" target=\"_blank\" class=\"edit_page\">Edit Page</a>\n<a href=\"javascript:void(0);\" onclick=\"delete_nav(this);\" class=\"delete\">{{ _('delete') }}</a>\n</span>\n\n      </div>\n\n    </li>{% if  config.children %}\n    <ol>{% for sub_config in config.children %}{{ create_nav_li(sub_config) }}\n{% endfor %}\n    </ol>\n{% endif %}\n{% endmacro %}\n\n    <div id=\"header\">\n      <div id=\"nav_disable_set\">{% if  site.nav_disabled %}\n        <input id=\"nav_disable\" type=\"checkbox\" checked=\"checked\"/>\n\n{% else %}\n        <input id=\"nav_disable\" type=\"checkbox\"/>\n\n{% endif %}\n<span>{{ _(\"Disable Custom Navigation\") }}</span>\n\n      </div>\n<a id=\"new_item\" href=\"#\">{{ _('+ New Item') }}</a>\n\n    </div>\n\n{% set nav_configs = site.nav_configs or [] %}\n\n    <div class=\"sortable_wrap\">\n      <ol class=\"sortable\">{% if  nav_configs %}{% for nav_config in nav_configs %}{{ create_nav_li(nav_config) }}\n{% endfor %}\n{% else %}{{ create_nav_li() }}\n{% endif %}\n\n      </ol>\n\n    </div>\n\n    <div class=\"note\">\n      <p>拖动即可调整次序、二级导航的归属；如果是站内链接 (URL), 请确保使用 / 开头。</p>\n\n    </div>\n<a id=\"save_nav\" href=\"#\">{{ _('Save') }}</a>\n\n    <div style=\"display:none\" class=\"li_template\">{{ create_nav_li() }}\n    </div>\n{{ h.load(\"essage\") }}\n\n    <script>var post_url = \"{{request.url}}\";\nvar site_id = \"{{site.id}}\";\n</script>\n  </body>\n\n</html>", 
    "page_user_register": "<html>\n  <header>\n    <title>Register</title>\n{{ h.mobile_metas }}\n{{ h.load('/fb_static/pages/page.css') }}\n\n    <style type=\"text/css\">.simple_form .buttons button { margin:0 10px !important;}\n</style>\n  </header>\n\n  <body>{{ h.i18n('Submit', '提交', 'zh_cn') }}\n{{ h.i18n('Invitation Code', '邀请码', 'zh_cn') }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">{% if  \"cn\" in request.lang %}\n          <h1>注册 / 新的Bucket</h1>\n\n{% else %}\n          <h1>Register / New Bucket</h1>\n\n{% endif %}\n\n        </div>\n\n        <div class=\"content_container\">{% if  \"cn\" in request.lang %}\n          <p><b>注册之前，请确保你已经理解:</b>\n\n          </p>\n          <p><span>1， 务必务必将 <b>私钥</b> 保存到某个地方，如果你遗失了它，就会失去对数据的控制，并且没有人可以帮到你。</span>\n\n          </p>\n          <p><span>2， 务必及时保存或同步自己的数据、文档到本地的设备中，网站/Bucket 也许会出错并且没有任何数据备份，如果在服务器上的数据因为过期、出错、删除，没有人可以帮你去找回来。</span>\n\n          </p>\n          <p><span>3， <b>没有人能帮到你</b> 就是 \"无能为力\" 的意思, 请不要发邮件跟我们询问你的<b>私钥</b>，我们真的不知道!</span>\n\n          </p>\n{% else %}\n          <p><b>Before Register, Make Sure You Understand:</b>\n\n          </p>\n          <p><span>1, Store the <b>Private Key</b> somewhere by yourself, if you lost it, you will lost the control of your data, and no one can help.</span>\n\n          </p>\n          <p><span>2, Store or sync all the data/documents by yourself at local devices in time, the bucket/website may crash and without any data backup, when the data on server is expired/crashed/deleted, no one can help you to find them back.</span>\n\n          </p>\n          <p><span>3, <b>No One Can Help</b> means \"no one can help\", do not send email to us to ask your Private Key that we really don't know!</span>\n\n          </p>\n{% endif %}\n{% if  register_note %}\n          <p>{{ register_note }}</p>\n\n{% endif %}{{ h.simple_form(\"\", ['invitation_code(type=input, title=\"Invitation Code\")'], submit_text=h.i18n(\"Submit\"), info=info) }}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>", 
    "builtin_theme_knowbase_search": "{% extends \"builtin_theme_knowbase_base.jade\" %}\n\n{% block title %}\n\n<title>{{ \"%s - %s\" % (request.args.s, wiki_title or site.title) }}</title>\n\n{% endblock %}\n\n{% block content %}\n\n<div class=\"common_page_wrap\">\n  <div class=\"common_page\">\n    <div class=\"common_page_core\">\n      <div class=\"page_header\"><a href=\"/wiki\" class=\"homepage\">Home</a>\n<span class=\"split\">></span>\n<span>{{ \"search: %s\"%request.args.s }}</span>\n\n      </div>\n\n      <div class=\"page_body\">{% for doc in docs %}\n        <div class=\"item\">\n{% set url = request.join(doc.wiki_url, keyword=request.args.s) %}\n<a href=\"{{'%s#main'%url}}\" >\n            <h2>{{ doc.highlight.title or doc.title }}</h2>\n</a>{% if  doc.highlight.content %}\n          <div class=\"summary\">{{ \"%s...\"%doc.highlight.content }}</div>\n\n{% else %}\n          <div class=\"summary\">{{ doc.metadata.summary or doc.content.plain.limit(120).plain }}</div>\n\n{% endif %}\n\n        </div>\n\n{% endfor %}{% if  not docs %}\n        <p class=\"note\">sorry, but no posts found</p>\n\n{% endif %}\n      </div>\n{{ h.paginator(style='auto') }}\n\n    </div>\n\n  </div>\n\n</div>\n\n{% endblock %}", 
    "page_file_info": "{{ response.set_content_type('application/json') }}\n\n{% set path = request.get_offset_path(1) %}\n\n{% set files = data.get_data(type=\"all\", path=path, level=1, fields=['path', '_type'], excludes=['settings.json', 'nav.json'],     limit=1000).filter(\"_type\", [\"post\", \"file\", \"image\", \"comments\", \"visits\"]) %}\n\n{% set files = d.sort_by_position(files) %}\n{% if  not path %}{{ files.insert({'path': 'settings.json', 'type':'file'}, position=0) }}\n{{ files.insert({'path': 'nav.json', 'type':'file'}, position=0) }}\n\n{% endif %}{{ files.json }}", 
    "api_syntax_modal": "{{ h.load(\"jquery\") }}\n{{ h.load('/fb_static/lib/jquery.modal.css') }}\n{{ h.load('/fb_static/lib/jquery.modal.js') }}\n{{ h.load('/fb_static/api/syntax/modal.css') }}\n{{ h.load('/fb_static/api/syntax/modal.js') }}\n{% if  ajax and url %}\n{% set a_class = 'modal_link ' %}\n{% if  button_class %}\n{% set a_class = a_class + button_class %}\n\n{% endif %}<a href=\"{{url}}\"  rel=\"modal:open\" id=\"{{dom_id or ''}}\"  class=\"{{a_class}}\" >{{ title or 'click' }}</a>\n\n{% else %}\n{% set css_style = \"display:none;\" %}\n{% if  width %}\n{% set css_style = css_style + \"width:%s;\"%width %}\n\n{% endif %}{% if  css %}\n{% set css_style = css_style + css %}\n\n{% endif %}\n<div id=\"{{dom_id}}\"  style=\"{{css_style}}\"  class=\"modal_wrap\">\n  <div class=\"modal_container\">{{ inner_html }}</div>\n\n</div>\n{% if  selector %}\n{% set selector = selector.replace('\"', \"'\") %}\n\n<input type=\"hidden\" data-modal-dom=\"{{'#%s'%dom_id}}\"  data-click-dom=\"{{\"%s\"%selector}}\"  class=\"modal_with_selector\"/>\n\n{% endif %}\n{% endif %}", 
    "page_web_editor": "<!DOCTYPE html>\n<html>\n  <head>\n<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n{{ h.headers }}\n\n    <title>Editor</title>\n{{ h.load('/fb_static/pages/web_editor/web_editor.css') }}\n\n  </head>\n\n  <body>{{ h.i18n(\"New Post\", \"新日志\", \"zh_cn\") }}\n\n    <div id=\"main\">\n      <div id=\"controls\">\n        <div class=\"cmds\"><a id=\"hide_controls\" data-bind=\"click: hide_controls\" href=\"#\"><i class=\"fa fa-arrow-left\"></i>\n</a>\n<a id=\"create_post\" data-bind=\"click: open_new_window\" href=\"#\"><i class=\"fa fa-plus\"></i>\n<span>{{ h.i18n(\"New Post\") }}</span>\n</a>\n\n        </div>\n\n        <ul id=\"posts\" data-bind=\"foreach: posts\" class=\"posts\">\n          <li><a data-bind=\"click: edit, event:{touchend: edit}\" href=\"#\" class=\"post\"><span data-bind=\"text: title\"></span>\n<span data-bind=\"text: path\" class=\"path\"></span><span data-bind=\"click: remove\" class=\"remove\">x</span>\n</a>\n\n          </li>\n        </ul>\n\n      </div>\n\n      <div id=\"editor\">\n        <input id=\"title\" type=\"text\" data-bind=\"value: current_post().title, event:{keyup: sync}\"/>\n<textarea id=\"textarea\"></textarea>\n\n      </div>\n\n      <div id=\"editor_save_button\" data-bind=\"visible:show_tip_info()\"><a data-bind=\"text: tip_info, click: _sync\" href=\"#\">Save</a>\n<span data-bind=\"style:{width: wait_to_sync_precess()}\" class=\"precess\"></span>\n\n      </div>\n\n      <div id=\"show_controls_button\"><a data-bind=\"click: show_controls\" href=\"#\"><i class=\"fa fa-arrow-right\"></i>\n</a>\n      </div>\n\n    </div>\n\n    <div id=\"new_window\">\n      <div id=\"window_bg\"></div>\n\n      <div class=\"main\">\n        <div id=\"new_window_body\">\n          <div data-bind=\"click:hide_new_window\" class=\"close\"><a href=\"#\"><i class=\"fa fa-times\"></i>\nclose\n</a>\n\n          </div>\n\n          <p>\n            <label>{{ '文件名' if request.lang=='zh_cn' else 'Filename' }}</label>\n\n            <input type=\"text\" id=\"new_path\" data-bind=\"event: {keyup: function(){if (event.keyCode == 13) create_new_one()}}\"/>\n\n          </p>\n\n          <p class=\"new_window_note\">{% if  request.lang=='zh_cn' %}Web版编辑器只显示最近30篇文章。\n\n{% else %}Web Editor only displays the recent 30 posts.\n\n{% endif %}\n\n          </p>\n\n          <p class=\"button\"><a href=\"#\" data-bind=\"click: create_new_one\">{{ '新日志' if request.lang=='zh_cn' else 'New Post' }}</a>\n\n          </p>\n\n        </div>\n\n      </div>\n\n    </div>\n{{ h.load('font') }}\n{{ h.load('essage') }}\n{{ h.load('/fb_static/pages/web_editor/jquery.min.js') }}\n{{ h.load('/fb_static/pages/web_editor/knockout-min.js') }}\n{{ h.load('/fb_static/pages/web_editor/jquery.dateFormat-1.0.js') }}\n{{ h.load('/fb_static/pages/web_editor/web_editor.js') }}\n\n    <script type=\"text/javascript\">run_editor()\n\n</script>{{ site.data_in_site_alert }}\n\n  </body>\n\n</html>", 
    "ajax": "{{ h.load('jquery') }}\n{{ h.load('/fb_static/api/form/ajax.js') }}\n\n{% set dom_id = '#'+dom_id %}\n\n<script>$(document).ready(function(){\n    $(\"{{dom_id}}\").click(function(){\n        {% if data %}\n            run_ajax_backend('{{url}}', '{{method}}', '{{callback}}', {{data}});\n        {% else %}\n            run_ajax_backend('{{url}}', '{{method}}', '{{callback}}');\n        {% endif %}\n    });\n});\n</script>", 
    "page_donate": "<html>\n  <header>\n    <title>Donate</title>\n{{ h.load('/fb_static/pages/page.css') }}\n\n  </header>\n\n  <body>\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>Donation for FarBox</h1>\n\n        </div>\n\n        <div class=\"content_container\">\n          <p><span>FarBox is a open source project, thanks for your donation. It will help FarBox grow better in the future.</span>\n<span>You can get the source code here <a href=\"https://github.com/hepochen/FarBox\" target=\"_blank\">https://github.com/hepochen/FarBox</a> or deploy to your own VPS by yourself.</span>\n\n          </p>\n\n          <p><span>Donate by Paypal：</span>\n<a href=\"https://www.paypal.me/hepochen\" target=\"_blank\">{{ \"https://www.paypal.me/hepochen\" }}</a>\n\n          </p>\n\n          <p><img src=\"/fb_static/donate/alipay.jpg\" style=\"max-width: 100px\"/>\n<span>（Alipay）</span>\n          </p>\n\n          <p><img src=\"/fb_static/donate/wechat.jpg\" style=\"max-width: 100px\"/>\n<span>（Wechat）</span>\n          </p>\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n</html>", 
    "auto_sidebar": "{% if  default_status == 'hide' %}\n<div class=\"sidebar_clicker click_to_open_sidebar\"><span class=\"bar\"></span>\n\n</div>\n\n{% else %}\n<div class=\"sidebar_clicker click_to_close_sidebar\"><span class=\"bar\"></span>\n\n</div>\n\n{% endif %}\n{% if  default_status == 'show' %}\n{% set default_position = 0 %}\n\n{% else %}\n{% set default_position = -sidebar_width %}\n\n{% endif %}\n{% if  side == 'right' %}\n<style type=\"text/css\">.sidebar_clicker{right:0; left:auto !important; }\n.{{sidebar_name}} {\n    right: {{ default_position }}px;\n    left: auto;\n    border-left: 1px solid #eee;\n\n    width: {{ sidebar_width }}px;\n    height: 100%;\n    top: 0;\n    position: fixed;\n    z-index: 1000;\n\n    background: #fafafa;\n}\n</style>\n{% else %}\n<style type=\"text/css\">.{{sidebar_name}} {\n    left: {{ default_position }}px;\n    right: auto;\n    border-right: 1px solid #eee;\n\n    width: {{ sidebar_width }}px;\n    height: 100%;\n    top: 0;\n    position: fixed;\n    z-index: 1000;\n    background: #fafafa;\n}\n\n\n\n</style>\n{% endif %}\n{{ h.load('jquery') }}\n{{ h.load('/fb_static/api/html/auto_sidebar/auto_sidebar.js') }}\n{{ h.load('/fb_static/api/html/auto_sidebar/auto_sidebar.css') }}\n\n<script>run_sidebar(\"{{side}}\", '{{sidebar_name}}', {{sidebar_width}}, \"{{ default_status }}\");\n</script>", 
    "api_syntax_page": "{% set dom_id = dom_id or 'list_container' %}\n{% if  as_ul %}\n<ul id=\"{{dom_id}}\" >{% if  caller %}{{ caller() }}\n{% endif %}\n</ul>\n{% else %}\n<div id=\"{{dom_id}}\"  style=\"width:100%;\">{% if  caller %}{{ caller() }}\n{% endif %}\n</div>\n{% endif %}\n\n<div id=\"on_loading\" style=\"display:none;width:100%;text-align:center\"><i class=\"fa fa-spinner fa-spin\"></i>\n\n</div>\n{{ h.load('font') }}\n{{ h.load('jquery') }}\n{{ h.load('/fb_static/api/syntax/page/load_pages.js') }}\n\n<script>auto_load_page_container_id = '{{dom_id}}'\n</script>{% if  callback %}\n<script>auto_load_page_callback = {{callback}};\n</script>\n{% endif %}", 
    "wechat_bind": "<html>\n  <header>\n    <title>绑定微信账户到 Bucket</title>\n{{ h.load('/fb_static/pages/page.css') }}\n{{ h.load('/fb_static/pages/table.css') }}\n\n    <style type=\"text/css\">#scan_by_wechat img{\n    margin: 0 auto;\n}\nh3{\n    text-align: center;\n    font-size: 14px;\n}\n.wechat img{\n    display: block;\n    margin: 0 auto;\n    border: 1px solid #eee;\n    max-width:80%;\n}\n\n.wechat_bitcron{\n    margin-top: 35px;\n}\n.note p{\n    margin: 3px auto;\n}\n\n</style>\n  </header>\n\n  <body>{{ h.i18n(\"Setup\", \"设置\", \"zh_cn\") }}\n\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>绑定微信账户到 Bucket</h1>\n\n        </div>\n\n        <div class=\"content_container\">\n          <h2>如何绑定？</h2>\n\n{% call tab([\"第一步:关注\", \"第二步:绑定\", \"小贴士\"]) %}\n\n          <div id=\"tab\">\n            <p style=\"text-align:center;margin-top:2em\"><b>第一步, 关注服务号并进入(如有需要可置顶服务号)</b>\n\n            </p>\n            <div class=\"wechat_accounts\">\n              <div id=\"wechat_account\"></div>\n{% if  wechat_account_url2 %}\n              <div id=\"wechat_account2\"></div>\n\n              <p>注意：任选其一即可，如果自己有多个 Bucket，可以分别择一，分场景各自使用。</p>\n\n              <style>.wechat_accounts {text-align: center;}\n#wechat_account, #wechat_account2 { display: inline !important}\n#wechat_account img, #wechat_account2 img { display: inline !important; margin: 2em; !important}\n\n</style>\n{% endif %}\n            </div>\n\n          </div>\n\n          <div id=\"tab\">\n            <p style=\"text-align:center;margin-top:2em\"><b>第二步, 点击 “管理” -> “扫码绑定”，并扫描下面二维码 (有效期 1 小时)</b>\n\n            </p>\n            <div id=\"scan_by_wechat\"></div>\n\n          </div>\n\n          <div id=\"tab\">\n            <p style=\"margin-top:2em\">1，一个 Bucket 可以绑定多个微信账户(最多50个)，而一个微信账户只能对应一个 Bucket；</p>\n\n            <p>2，多人协作的时候，可以先输入 <b>name 自己的昵称</b> 来设定名称，并在设置项中 `添加昵称`;</p>\n\n            <p>3，<a href=\"/__site_json_settings?path=wechat\" target=\"_blank\">微信发布的设定</a> 有更多的设定项，按照自己的需要调整；</p>\n\n            <p>4, 支持 #标签 的语法，但最终会转化为 [[#标签]] 这种 FarBox 的对应语法；</p>\n\n            <p>5，当日发布的内容，会汇总到一篇文章当中，也是 Markdown 的语法，如果一天的第一条内容是 <b>title: 文章的名称</b> 也同样会起到 Meta 声明的作用；</p>\n\n            <p>6，还可以直接发语音，会自动转化为文字，进行超高效的输入，如果结尾补充`标签 关键字(5字以内)`会自动识别为标签的语法;</p>\n\n            <p>7，如果设置了 `One User One Post` 请同时设置 `Post Folder`，并且告诉最终使用者可以使用 `reset` 命令重置。</p>\n\n          </div>\n\n{% endcall %}\n{% if  wechat_user_docs %}\n          <h2>当前已绑定的账户</h2>\n\n          <table>\n            <thead>\n              <tr>\n                <th>Uid</th>\n\n                <th>Name</th>\n\n                <th>Date</th>\n\n              </tr>\n\n            </thead>\n\n            <tbody>{% for doc in wechat_user_docs %}\n              <tr>\n                <td>{{ doc.uid }}</td>\n\n                <td>{{ doc.name }}</td>\n\n                <td>{{ doc.date }}</td>\n\n              </tr>\n\n{% endfor %}\n            </tbody>\n          </table>\n\n{% endif %}\n        </div>\n\n      </div>\n\n    </div>\n{{ h.load(\"jquery\") }}\n{{ h.load(\"/fb_static/lib/jquery.qrcode.min.js\") }}\n\n    <script>var qrcode1 = new QRCode(document.getElementById(\"scan_by_wechat\"), {\n        text: \"{{bind_code}}\",\n        width: 200,\n        height: 200,\n        colorDark : \"#000000\",\n        colorLight : \"#ffffff\",\n        correctLevel : QRCode.CorrectLevel.H\n});\n\nvar qrcode2 = new QRCode(document.getElementById(\"wechat_account\"), {\n        text: \"{{wechat_account_url}}\",\n        width: 200,\n        height: 200,\n        colorDark : \"#000000\",\n        colorLight : \"#ffffff\",\n        correctLevel : QRCode.CorrectLevel.H\n});\n</script>{% if  wechat_account_url2 %}\n    <script>var qrcode3 = new QRCode(document.getElementById(\"wechat_account2\"), {\n        text: \"{{wechat_account_url2}}\",\n        width: 200,\n        height: 200,\n        colorDark : \"#000000\",\n        colorLight : \"#ffffff\",\n        correctLevel : QRCode.CorrectLevel.H\n});\n</script>\n{% endif %}\n  </body>\n\n</html>", 
    "builtin_api_referred_post": "{% if  inline %}<a href=\"{{post_url}}\" >{{ sub_post.title }}</a>\n\n{% else %}\n<div class=\"clear\"></div>\n\n<div class=\"post_preview\">\n{% set preview_meta_class = \"with_bg post_preview__meta\" if sub_post.cover else 'without_bg post_preview__meta' %}\n\n  <div class=\"{{preview_meta_class}}\" >\n    <div class=\"post_preview__middle\">\n      <h4 class=\"post_preview__title\"><a href=\"{{post_url}}\" >{{ sub_post.title }}</a>\n\n      </h4>\n{% if  show_date %}\n      <time class=\"post_preview__date\">{{ sub_post.date('%Y/%m/%d') }}</time>\n\n{% endif %}\n      <section class=\"post_preview__summary\">{% if  sub_post.metadata.summary %}<span>{{ sub_post.metadata.summary }}</span>\n\n{% else %}{% if  sub_post.cover %}<span>{{ sub_post.content.limit(words=30, keep_images=False).plain }}</span>\n\n{% else %}<span>{{ sub_post.content.limit(words=86, keep_images=False).plain }}</span>\n\n{% endif %}\n\n{% endif %}\n\n      </section>\n\n    </div>\n\n  </div>{% if  sub_post.cover %}\n{% set bg_url = sub_post.cover.small_thumbnail %}\n\n  <div style=\"background-image:url({{bg_url}})\" class=\"post_preview__image\"></div>\n\n{% endif %}\n</div>\n\n{% endif %}", 
    "page_admin_buckets_usage": "<html>\n  <header>\n    <title>Buckets Usage</title>\n{{ h.load('/fb_static/pages/page.css') }}\n{{ h.load('/fb_static/pages/table.css') }}\n\n  </header>\n\n  <body>\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>{{ h.i18n(\"Usage\") }}</h1>\n\n        </div>\n\n        <div class=\"content_container\">\n          <h2>{{ h.i18n(\"Bandwidth\") }}</h2>\n\n          <table class=\"usage\">\n            <thead>\n              <tr>\n                <th>Bucket</th>\n\n                <th>Bandwidth</th>\n\n                <th>ExpiredDate</th>\n\n              </tr>\n\n            </thead>\n\n            <tbody>{% for u in bandwidth_usage %}\n              <tr>\n                <td><span>{{ u.bucket }}</span>\n<small style=\"color:#777\">{{ b.get_domains(u.bucket).join(\",\") }}</small>\n\n                </td>\n\n                <td>{{ u.value }}</td>\n\n                <td>{{ b.get_expired_date(u.bucket) }}</td>\n\n              </tr>\n\n{% endfor %}\n            </tbody>\n          </table>\n\n          <hr/>\n\n          <h2>{{ h.i18n(\"Storage\") }}</h2>\n          <table class=\"usage\">\n            <thead>\n              <tr>\n                <th>Bucket</th>\n\n                <th>Storage</th>\n\n              </tr>\n\n            </thead>\n\n            <tbody>{% for u in store_usage %}\n              <tr>\n                <td><span>{{ u.bucket }}</span>\n<small style=\"color:#777\">{{ b.get_domains(u.bucket).join(\",\") }}</small>\n\n                </td>\n\n                <td>{{ u.value }}</td>\n\n              </tr>\n\n{% endfor %}\n            </tbody>\n          </table>\n\n          <hr/>\n\n          <h2>{{ h.i18n(\"Request\") }}</h2>\n          <table class=\"usage\">\n            <thead>\n              <tr>\n                <th>Bucket</th>\n\n                <th>Request</th>\n\n              </tr>\n\n            </thead>\n\n            <tbody>{% for u in request_usage %}\n              <tr>\n                <td>{{ u.bucket }}</td>\n\n                <td>{{ u.value }}</td>\n\n              </tr>\n\n{% endfor %}\n            </tbody>\n          </table>\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n</html>", 
    "page_user_json_settings_ui": "<html>\n{% set keys_config_path = request.values.path or request.values.type %}\n\n{% set keys_config = site.get_settings_keys_config(keys_config_path) %}\n\n  <header>{{ h.mobile_metas }}\n{{ h.load('pure') }}\n{{ h.load('/fb_static/pages/page.css') }}\n\n    <title>{{ keys_config.title or \"Settings\" }}</title>\n{{ h.mobile_metas }}\n\n  </header>\n\n  <body>\n    <style type=\"text/css\">body {margin:3em auto 0 !important}\n@media screen and (min-width: 800px){\n    .dom_list_for_routes input, .dom_list_for_dns_mx input, .dom_list_for_dns_txt input{\n        width: 150px !important;\n    }\n    .dom_list_for_routes select{\n        width: 150px !important;\n        display: inline;\n    }\n    .one_line .dom_list_body select{\n        width: 150px !important;\n        display: inline;\n    }\n    .one_line .dom_list_body input{\n        width: 150px !important;\n    }\n}\n.dom_list_add_action, .dom_list_delete_action:hover{\n    color: white !important;\n}\n.dom_list_delete_action{color: #777 !important;}\n\n</style>\n    <div class=\"post\">\n      <div class=\"post_body\">\n        <div class=\"title_container\">\n          <h1>{{ keys_config.title or \"Settings\" }}</h1>\n\n        </div>\n\n        <div class=\"content_container\">{% if  keys_config.note %}\n          <p><span>Note:</span>\n<span>{{ keys_config.note }}</span>\n\n          </p>\n\n{% endif %}{{ site.settings_json_editor(keys_config_path) }}\n\n        </div>\n\n      </div>\n\n    </div>\n\n  </body>\n\n</html>"
}